#  (gH)   --  galg.tcl  ;  TimeStamp (unix) : 31 Juillet 03 11:57

set gVersion 2.33

# *****************************************************************
# *****************************************************************
# *                                                               *
# *                Construction de l'interface                    *
# *                                                               *
# *****************************************************************
# *****************************************************************

proc construitMenus {} {  global  lstLang verLang

    menu .menubar

    menu .menubar._Fichier      -tearoff 0
    menu .menubar._Edition      -tearoff 0
    menu .menubar._Insertion    -tearoff 0
    menu .menubar._Analyse      -tearoff 0
    menu .menubar._Traduction   -tearoff 0
    menu .menubar._Execution    -tearoff 0
    menu .menubar._Exemples     -tearoff 0
    menu .menubar._Aide         -tearoff 0

    # menu Fichier

    .menubar add cascade -label " Fichier " -menu .menubar._Fichier -underline 1

    .menubar._Fichier add command -label "Nouveau"                           -command nouveauFichier    -accelerator "Ctrl+N"
    .menubar._Fichier add command -label "Ouvrir un fichier-algorithme..."   -command ouvreFichier      -accelerator "Ctrl+F"
    .menubar._Fichier add command -label "Rouvrir le fichier-algorithme..." -command reOuvreFichier    -accelerator "Ctrl+O"
    .menubar._Fichier add command -label "Enregistrer"                       -command enregistrer       -accelerator "Ctrl+S"
    .menubar._Fichier add command -label "Enregistrer sous ..."              -command enregistrerSous   -accelerator "Ctrl+W"
    .menubar._Fichier add separator
    .menubar._Fichier add command -label "Recrer les scripts d'excution standard"   -command recreeScripts     -accelerator "Ctrl+Z"
    .menubar._Fichier add separator
    .menubar._Fichier add command -label "Quitter"                 -command quitter         -accelerator "Ctrl+Q"
    .menubar._Fichier add command -label "Exit (sans sauvegarde)"  -command quitter         -accelerator "Ctrl+X"

    # menu Edition

    .menubar add cascade -label " Edition " -menu .menubar._Edition -underline 1

    .menubar._Edition add command -label "Aller  la ligne ..."                            -command allerALaLigne    -accelerator "Ctrl+J"
    .menubar._Edition add command -label "Aller  la 1re erreur dtecte" -state disabled -command premiereErreur   -accelerator "Ctrl+E"
#    .menubar._Edition add command -label "Copier"                                                                    -accelerator "Ctrl+C"
#    .menubar._Edition add command -label "Coller"                                                                    -accelerator "Ctrl+V"
    .menubar._Edition add command -label "Dtruire la ligne"                               -command detruitLigne     -accelerator "Ctrl+Y"
    .menubar._Edition add command -label "Paramtres d'excution"                          -command parametresExec   -accelerator "Ctrl+R"
    .menubar._Edition add separator
    .menubar._Edition add command -label "Taille plus grande"                              -command { taille "+" }   -accelerator "Ctrl +"
    .menubar._Edition add command -label "Taille plus petite"                              -command { taille "-" }   -accelerator "Ctrl -"
    .menubar._Edition add separator
    .menubar._Edition add command -label "Bascule mode Dbutant / Expert"                  -command modeExpert       -accelerator "Ctrl+B"

    # menu Insertion

    .menubar add cascade -label " Insertion " -menu .menubar._Insertion -underline 2

    .menubar._Insertion add command -label "Insrer un commentaire"                          -command insereCommentaire -accelerator "Ctrl+I"
    .menubar._Insertion add command -label "Insrer l'auteur"                                -command insereAuteur
    .menubar._Insertion add separator
    .menubar._Insertion add command -label "Insrer ECRIRE"                                  -command insereEcrire
    .menubar._Insertion add command -label "Insrer LIRE"                                    -command insereLire
    .menubar._Insertion add command -label "Insrer une AFFECTATION ..."                     -command insereAffectation
    .menubar._Insertion add command -label "Insrer une boucle POUR"                         -command insereBouclePour
    .menubar._Insertion add command -label "Insrer un test SI...ALORS"                      -command insereSi
    .menubar._Insertion add command -label "Insrer un test SI...ALORS...SINON"              -command insereSinon
    .menubar._Insertion add command -label "Insrer une boucle TANT QUE"                     -command insereTantQue
    .menubar._Insertion add separator
    .menubar._Insertion add command -label "Insrer OUVRIR Fichier EN LECTURE"               -command insereOuvrirFichierEnLecture
    .menubar._Insertion add command -label "Insrer OUVRIR Fichier EN ECRITURE"              -command insereOuvrirFichierEnEcriture
    .menubar._Insertion add command -label "Insrer ECRIRE sur Fichier"                      -command insereEcriresurFichier
    .menubar._Insertion add command -label "Insrer LIRE sur Fichier"                        -command insereLiresurFichier
    .menubar._Insertion add command -label "Insrer FERMER Fichier"                          -command insereFermerFichier

    # menu Analyse

    .menubar add cascade -label " Analyse " -menu .menubar._Analyse -underline 1

    if { [string toupper $verLang("Galg")] !="ABSENT"} {
       set etatCmd "disable"
    }  else {
       set etatCmd "normal"
    } ; # fin de si

    .menubar._Analyse add command -label "Lancer l'analyse"                               -command analyser -state $etatCmd   -accelerator "Ctrl+G"
    .menubar._Analyse add separator
    .menubar._Analyse add command -label "Voir l'algorithme"              -state disabled -command voirAlgo      -accelerator "Ctrl+A"
    .menubar._Analyse add command -label "Voir le fichier rsultat"       -state disabled -command voirListing   -accelerator "Ctrl+L"
    .menubar._Analyse add command -label "Voir le fichiers des variables" -state disabled -command voirVariables -accelerator "Ctrl+M"

    # menu Traduction

    .menubar add cascade -label " Traduction " -menu .menubar._Traduction -underline 1

    foreach lang $lstLang  {
      if {$lang!="Galg"} {  # attention : galg est mis dans la liste des langages
         # on n'affiche que les langages dtects
         if { [string toupper $verLang("$lang")] !="ABSENT"} {
            set cmd  "add command -label \"$lang\" -command \{traduire $lang \}"
            # on dsactive si Galg non dtect
            if {[string toupper $verLang("Galg")]=="ABSENT"} { append cmd " -state disabled" }
            eval ".menubar._Traduction $cmd"
         } ; # fin de si sur langage
      } ; # fin de si sur lang=galg
    } ; # fin de pour chaque langage

    .menubar._Traduction add separator
    set cmd  "add command -label \"Voir la traduction\" -command voirTraduction -state disabled -accelerator Ctrl+T"
    eval ".menubar._Traduction $cmd"

    # menu Excution

    .menubar add cascade -label " Excution " -menu .menubar._Execution  -underline 2

    foreach lang $lstLang  {
      if {$lang!="Galg"} {  # attention : galg est mis dans la liste des langages
         set finCmd " executer $lang"
         # on dsactive si Galg non dtect
         if {[string toupper $verLang("Galg")]=="ABSENT"} { set finCmd "-state disabled" }
         # on ne peut pas excuter si Rexxd non dtect
         if {[string toupper $verLang("Rexx")]=="ABSENT"} { set finCmd "-state disabled" }
         # on n'affiche que les langages dtects
         if { [string toupper $verLang("$lang")] !="ABSENT"} {
            set cmd  "add command -label \"$lang\" -command \{ $finCmd \}"
            eval ".menubar._Execution $cmd"
         } ; # fin de si sur langage
      } ; # fin de si sur lang=galg
    } ; # fin de pour chaque langage

    # menu Exemples

    .menubar add cascade -label " Exemples "  -menu .menubar._Exemples  -underline 2

    .menubar._Exemples add command -label "Bonjour amlior"           -command { exemple "bonjour"  }  -accelerator "Ctrl+1"
    .menubar._Exemples add command -label "Nombre de secondes An 2000" -command { exemple "secondes" }  -accelerator "Ctrl+2"
    .menubar._Exemples add command -label "Table de multiplication"    -command { exemple "tabmult"  }  -accelerator "Ctrl+3"
    .menubar._Exemples add command -label "Conversion Franc/Euro"      -command { exemple "cfe"      }  -accelerator "Ctrl+4"
    .menubar._Exemples add command -label "Occurences du maximum"      -command { exemple "maxocc"   }  -accelerator "Ctrl+5"
    .menubar._Exemples add command -label "Recherche de texte"         -command { exemple "brutese"  }  -accelerator "Ctrl+6"
    .menubar._Exemples add command -label "MacNaughton"                -command { exemple "glouton"  }  -accelerator "Ctrl+7"
    .menubar._Exemples add command -label "Tri-Fusion de fichiers"     -command { exemple "trifus"   }  -accelerator "Ctrl+8"
    .menubar._Exemples add command -label "Dictionnaires d'un texte"   -command { exemple "creedic"  }  -accelerator "Ctrl+9"

    # menu "Aide"

    .menubar add cascade -label "  Aides  "  -menu .menubar._Aide -underline 3

    .menubar._Aide add command -label "Aide sur Galg"      -command aideWeb              -accelerator "Ctrl+H"
    .menubar._Aide add command -label "Langages supports" -command langagesSupportes    -accelerator "Ctrl+U"
    .menubar._Aide add command -label "Langages prsents"  -command langagesPresents     -accelerator "Ctrl+D"
    .menubar._Aide add separator
    .menubar._Aide add command -label "Liste des raccourcis clavier"   -command aideClavier   -accelerator "Ctrl+K"
    .menubar._Aide add command -label "A propos..."                    -command aPropos       -accelerator "Ctrl+P"

    return .menubar

} ; # fin proc construitMenu

# ********************************************************************************

proc construitEditeur {} {

    frame .editeur ;  # un cadre pour tout abriter
    frame .nblignes ; # place pour affiche les numros de ligne et de colonne

    # zone d'dition du texte

    text .editeur.texte -background white -foreground black -wrap none -font {Courier 12} \
         -xscrollcommand {.editeur.xScroller set} -yscrollcommand {.editeur.yScroller set} -height 5 -width 5

    # ascenseur vertical et horizontal

    scrollbar .editeur.xScroller -orient horizontal -command {.editeur.texte xview}
    scrollbar .editeur.yScroller -orient vertical -command {.editeur.texte yview}

    grid .editeur -padx 5 -in .
    grid .editeur.texte -row 0 -column 0 -sticky news
    grid rowconfigure .editeur 0 -weight 1
    grid columnconfigure .editeur 0 -weight 1
    grid .editeur.xScroller -row 1 -column 0 -sticky wes
    grid rowconfigure .editeur 1 -weight 0
    grid .editeur.yScroller -row 0 -column 1 -sticky sne
    grid columnconfigure .editeur 1 -weight 0

    return .editeur

} ; # fin proc construitEditeur

# ********************************************************************************

proc construitBarreDeStatut {} { global modeAff

    frame .barreDeStatut
    label .barreDeStatut.expert     -text "   "                 -justify left  -relief sunken  -font { Courier 12 }      -fg red  -width   4
    label .barreDeStatut.etaFichier -text "             "       -justify left  -relief sunken  -font { Courier 12 }      -fg red  -width  10
    label .barreDeStatut.nomFichier -text " Nouvel algorithme " -justify left  -relief sunken  -font { Courier 12 }               -width 120
    label .barreDeStatut.coordLt    -text " Ligne "             -justify right -relief sunken  -font { Courier 12      } -fg blue -width   7
    label .barreDeStatut.coordLv    -text "     "               -justify right -relief sunken  -font { Courier 12 bold }          -width   5
    label .barreDeStatut.coordCt    -text " Colonne "           -justify right -relief sunken  -font { Courier 12      } -fg blue -width   9
    label .barreDeStatut.coordCv    -text "     "               -justify right -relief sunken  -font { Courier 12 bold }          -width   5

    grid .barreDeStatut -padx 1 -in .
    grid .barreDeStatut.expert     -row 0 -column 0 -sticky nws
    grid .barreDeStatut.etaFichier -row 0 -column 1 -sticky nws
    grid .barreDeStatut.nomFichier -row 0 -column 2 -sticky nws
    grid .barreDeStatut.coordLt    -row 0 -column 3 -sticky nes
    grid .barreDeStatut.coordLv    -row 0 -column 4 -sticky nes
    grid .barreDeStatut.coordCt    -row 0 -column 5 -sticky nes
    grid .barreDeStatut.coordCv    -row 0 -column 6 -sticky nes

    grid columnconfigure .barreDeStatut 0 -weight 0
    grid columnconfigure .barreDeStatut 1 -weight 0
    grid columnconfigure .barreDeStatut 2 -weight 5
    grid columnconfigure .barreDeStatut 3 -weight 0
    grid columnconfigure .barreDeStatut 4 -weight 0
    grid columnconfigure .barreDeStatut 5 -weight 0
    grid columnconfigure .barreDeStatut 6 -weight 0
    grid rowconfigure    .barreDeStatut 0 -weight 0

    return .barreDeStatut

    return

} ; # fin proc construitBarreDeStatut


# *************************************************************************
# *************************************************************************
# *                                                                       *
# *    Procdures  de gestion de l'affichage                              *
# *                                                                       *
# *************************************************************************
# *************************************************************************


proc tailleWin { } { # dfinition de la taille en fonction de la rsolution de l'cran

     set nw     785
     set nh     500
     set ww     [winfo screenwidth  .]
     set wh     [winfo screenheight .]
     set decale 5
     if { [expr ($ww-$nw)*($wh-$nh)] > 0 }  {
        set factP 0.8 ; # facteur (pourcentage) de rduction
        set nw  [expr round($ww*$factP)] ;
        set nh  [expr round($wh*$factP)] ;
        set decale 25 ; # dclage des bords
     } ; # fin si
     set     ghm "wm geometry . $nw"
     append  ghm "x$nh+$decale+$decale"
     eval    $ghm

} ; # fin proc tailleWin

# ********************************************************************************

proc modeExpert { } { global modeAff

  # on met D (dbutant) ou E (expert) en bas  gauche

  if { $modeAff == "Dbutant" } { set modeAff "Expert" } else { set modeAff "Dbutant" }
  .barreDeStatut.expert configure -text " [string index $modeAff 0] "

} ; # fin proc modeExpert

# ********************************************************************************

proc afficheEtat { valEtat } { global etatF

   # indique si le texte dans l'diteur a t modifi

  .barreDeStatut.etaFichier configure -text "  $valEtat "

  if { [string trim $valEtat] == "modifi" } {
     set etatF 0
     menusAnalyse   "normal"
     menusInsertion "normal"
     menusTradExec  "disabled"
  } ; # finsi valEtat est "modifi"

} ; # fin proc afficheEtat

# ********************************************************************************

proc taille { parmT } {

  # change la taille du texte affich dans l'diteur

  set tailleEd [lindex [.editeur.texte cget -font] 1]
  set valInc   4  ; # 1 et 2 semblent trop petits
  if { $parmT == "+" } {
     set tailleEd [expr $tailleEd + $valInc ]
  } else {
     set tailleEd [expr $tailleEd - $valInc ]
     if { $tailleEd <0 } { set tailleEd 0 }
  } ; # fin de si
  eval ".editeur.texte configure  -font { Courier $tailleEd }"
  set tailleEd [lindex [.editeur.texte cget -font] 1]

} ; # fin proc diminue_Taille

# ********************************************************************************

proc afficheNums { numLig numCol } {

  .barreDeStatut.coordLv configure -text [format " %3d " $numLig ]
  .barreDeStatut.coordCv configure -text [format " %3d " [expr 1+$numCol] ]

} ; # fin proc affichenumCol

# ********************************************************************************

proc majNums {} {

   regexp {(.*)[.](.*)} [.editeur.texte index insert] -> ligneNo colonneNo
   afficheNums $ligneNo $colonneNo

} ; # fin proc majNums

proc dateHeure { } {
  return [clock format [clock seconds] -format "%d/%m/%Y  %H:%M.%S"]
} ; # fin proc dateHeure

# ********************************************************************************


# *************************************************************************
# *************************************************************************
# *                                                                       *
# *    Procdures de gestion des menus                                    *
# *                                                                       *
# *************************************************************************
# *************************************************************************

proc menusInsertion { etatI } {

  for {set i 0} {$i < 16} {incr i} {
      set actif 1
      if { $i ==  2 } { set actif 0 } ; # sparateur
      if { $i == 10 } { set actif 0 } ; # sparateur
      if { $actif == 1 } {  eval ".menubar._Insertion entryconfigure $i -state $etatI " }
  } ; # fin pour i

} ; # fin proc menusInsertion

# ********************************************************************************

proc menusAnalyse { etatA } { global etatF

  for {set i 0} {$i < 5} {incr i} {
      if { $i != 1 } { # car 2 est le sparateur
           eval ".menubar._Analyse entryconfigure $i -state $etatA"
      } ; # fin si
      if { $i >= 2 } {
         if { $etatF == 0 } {
             .menubar._Analyse entryconfigure $i -state disabled
         } ; # fin si
      } ; # fin si i >= 2
  } ; # fin pour  i

} ; # fin proc menusInsertion

# ********************************************************************************

proc menusTradExec { etatB } { global verLang lstLang

  # en fonction des langages dtects, on propose certains des menus "Traduction"

  set indLang 0
  foreach lang $lstLang  {
    if {$lang!="Galg"} {  # attention : galg est mis dans la liste des langages
       # on n'autorise que les langages dtects
       set actif 0
       if { [string toupper $verLang("$lang")] =="ABSENT"} { set actif 1 }
       if { [string toupper $verLang("Galg")]  =="ABSENT"} { set actif 0 }
       if { $actif == 1 } {
            eval ".menubar._Execution   entryconfigure $indLang -state $etatB"
       } ; # finsi on active le langage
    } ; # fin de si sur lang=galg
    set indLang [incr indLang]
  } ; # fin de pour chaque langage

  # le menu "voir la traduction" est  priori dsactiv

  eval ".menubar._Traduction entryconfigure 9 -state $etatB"

} ; # fin proc menusTradExec


# *************************************************************************
# *************************************************************************
# *                                                                       *
# *    Procdure de gestion des touches                                   *
# *                                                                       *
# *************************************************************************
# *************************************************************************

proc forceAncv { } { global ancV

  set ancV [.editeur.texte get 0.0 end]

} ; # fin proc forceAncv

proc filtreTouche  { laTouche } { global prevCar naturF action  ancV

  ecritDbg  " touche $laTouche  pre $prevCar "

  # pour windows, on filtre les touches du pav numrique

  if { [lsearch -exact "Control_L Control_R Tab" [string trim $laTouche] ] > -1 } {
     if { [lsearch -exact "1 2 3 4 5 6 7 8 9" $prevCar] > -1 } {
           exemple $prevCar
           forceAncv
     } ; # fin un chiffre
  } ; # fin si touche controle

  set newV [.editeur.texte get 0.0 end]

  set prevCar $laTouche
  ecritDbg  " tailles [string length $ancV] et [string length $newV]\n"

  if { $ancV != $newV } {
       afficheEtat " modifi "
  } ; # finsi on a modifi

} ; # proc filtreTouches

# ********************************************************************************

proc gestionEvenements {} { global fichierModifie fichierAlg lstNoModif prevCar ancV fDbg naturF action

    # mise  jour des coordonnes du symbole d'insertion dans la barre d'tat
    # l'utilisateur relache une touche du clavier

    bind .editeur.texte <KeyPress>   {

      set action 1
      majNums
      if { $naturF == "alg" } {
         set ancV [.editeur.texte get 0.0 end]
         ecritDbg " <KeyPress> %K $action : taille [string length $ancV]"
         puts " <KeyPress> %K $action : taille [string length $ancV]"
      } ; # fin dition algorithme

    } ; # finsi KeyPress

    bind .editeur.texte <KeyRelease> {

#      if { $naturF == "alg" } {
         set newV [.editeur.texte  get 0.0 end]
         ecritDbg "\n <KeyRelease> %K $action : taille [string length $newV]"
         puts "\n <KeyRelease> %K $action : taille [string length $newV]"
         filtreTouche [string trim "%K"]
#      } ; # fin dition algorithme

    } ; # fin .editeur.texte <KeyRelease>

    bind .editeur.texte <ButtonRelease-1> {
         majNums
    }  ; # fin .editeur.texte <ButtonRelease-1>

    bind .editeur.texte <ButtonRelease-2> {
         majNums
    }  ; # fin .editeur.texte <ButtonRelease-2>

} ; # fin proc gestionEvenements

# *************************************************************************
# *************************************************************************
# *                                                                       *
# *    Procdures  d'affichage de textes et messages  utilisateurs        *
# *                                                                       *
# *************************************************************************
# *************************************************************************


proc panoInfo { titPano txtPano } {

  toplevel      .dialogue
  wm title      .dialogue $titPano
  wm transient  .dialogue .
  grab          .dialogue
  focus         .dialogue
  label         .dialogue.msgLbl   -text $txtPano -font { Courier } -width 70
  label         .dialogue.videLbl1 -text ""
  button        .dialogue.fermer   -text "Fermer " -command { destroy .dialogue } -bg blue -fg yellow
  label         .dialogue.videLbl2 -text ""
  bind          .dialogue <Return> { .dialogue.fermer invoke }
  pack          .dialogue.msgLbl .dialogue.videLbl1 .dialogue.fermer .dialogue.videLbl2
  focus  -force .dialogue.fermer

} ; # fin proc panoInfo

# ********************************************************************************

proc msgInfo { txtMsg } {

  tk_messageBox -parent . -title " pour information " -type ok -icon info -default ok -message $txtMsg

} ; # fin proc msgInfo


# *************************************************************************
# *************************************************************************
# *                                                                       *
# *                   Visualisation des fichiers                          *
# *                                                                       *
# *************************************************************************
# *************************************************************************

proc voirFichier { naturFic } { global fichierAlg fichierModifie fichierTraduit nomAlg naturF etatF nbErr ancV

    set naturF $naturFic

    # rien  faire pour nouvel algorithme

    if { $fichierAlg == "Nouvel algorithme"} { return }

    # si pas de langage, on le dit

    if { $naturF == ""} {
       msgInfo  " Impossible, vous n'avez pas traduit ! "
       return
    } ; # fin si

    # on prpare le fichier  voir

    if { $naturF == "alg" } {

       set fichierAvoir  $fichierAlg
       regexp {(.*).alg} $fichierAlg ->  nomAlg

    } else {

       append fichierAvoir $nomAlg ".$naturF"

    } ; # fin si

    # on essaie de lire le fichier

    if [catch {open $fichierAvoir "r" } fileId] {
          tk_messageBox -parent . -title "Erreur" -message "Impossible d'ouvrir $fichierAvoir" -icon error -type ok
          return
    } ; # fin de si on ne peut pas lire le fichier

    # si on l'a lu, on l'affiche

    set fichierModifie false
    .editeur.texte configure -state normal      ; #  autorise la modification du texte dans l'diteur
    .editeur.texte delete 0.0 end ; # efface le texte prsent dans l'diteur

    # on lit le fichier en filtrant les caractres

    .editeur.texte insert 0.0 "[string trimright [read $fileId] "\n"]\n"
    pack .editeur
    close $fileId

    .barreDeStatut.nomFichier configure -text "   $fichierAvoir " -justify left
    afficheEtat " "

    if { $nbErr > 0 } {
       activeAllerErreur "normal"
    } else {
       activeAllerErreur "disabled"
    } ; # fin si

    menusAnalyse   "normal"
    if { $naturF == "alg" } {
        .editeur.texte configure -state normal ; # Autorise les modifications dans l'diteur
        menusInsertion "normal"
    } else {
        lectureSeule $fichierAvoir ; # diteur en lecture seule
    } ; # finsi


   if { $etatF < 2 } {
      menusTradExec "disabled"
   } else {
      menusTradExec "normal"
   } ; # finsi non traduit

   # on finit en se positionnant en dbut de fichier si fichier non vide...

   if { [string length [.editeur.texte get 0.0 end]] > 0 } { .editeur.texte see 1.0 }

   # et en prvenant le filrage de touche de l'dition

   set ancV [.editeur.texte get 0.0 end]

} ; # fin proc voirFichier

# ********************************************************************************

proc voirAlgo { } {
  voirFichier "alg"
} ; # fin proc voirAlgo

# ********************************************************************************

proc voirListing { } { global etatF nbErr

   if { $etatF == 0 } {
       msgInfo  " Impossible, vous n'avez pas analys votre algorithme. "
       return
   } ; # fin si
   voirFichier "lst"

} ; # fin proc voirListing

# ********************************************************************************

proc voirVariables { } { global etatF

   if { $etatF == 0 } {
       msgInfo  " Impossible, vous n'avez pas analys votre algorithme. "
       return
   } ; # fin si
   voirFichier "lvm"

} ; # fin proc voirVariables

# ********************************************************************************

proc voirTraduction { } { global lstLang extLang langU etatF

   if { $etatF < 2 } {
       msgInfo  " Impossible, vous n'avez pas traduit votre algorithme. "
       return
   } ; # fin si

   voirFichier [extlang $langU]

} ; # fin proc voirTraduction

# ********************************************************************************

proc extlang { lang } { global lstLang extLang # renvoie l'extension de fichier associe  la langue

   set indExt  [lsearch -exact $lstLang $lang ]
   if { $indExt > -1 } {
       return [lindex  $extLang $indExt]
   } else {
       return "xxx"
   } ; # fin de si

} ; # fin proc extlang { lang } {

# *************************************************************************
# *************************************************************************
# *                                                                       *
# *                               Fichier                                 *
# *                                                                       *
# *************************************************************************
# *************************************************************************

proc valEtat { } { # renvoie la valeur du champ etaFichier dans la ligne du bas

  return [string trim [.barreDeStatut.etaFichier cget -text]]

} ; # fin proc valEtat

# ********************************************************************************

proc testeEnregistrer { } {

  set valret 0
  if { [valEtat] == "modifi" } {
     set valret 1
     set valret [proposeEnregistrer]
  } ; # finsi modifi
  return $valret

} ; # proc testeEnregistrer

# ********************************************************************************

proc lectureSeule { nomFich } {

  .barreDeStatut.nomFichier configure -text " $nomFich (non modifiable)"
  .editeur.texte configure -state disabled
  afficheEtat " "
  afficheNums 1 0
  menusInsertion "disabled"

} ; # proc lectureSeule

# ********************************************************************************

proc ouvreFichier { } { global fichierAlg fichierModifie

    # si modifi, on propose d'enregistrer

    if { [testeEnregistrer] == 1 } {
      msgInfo " le fichier courant n'est pas enregistr, ouverture d'un nouveau fichier impossible."
      return
    } ; # finsi

    # on propose le panneau classique de choix de fichier

    set type { {{Algorithmes} {.alg}}}
    set nouveauFichier [tk_getOpenFile -filetypes $type -title "Ouvrir un algorithme ..."]

    # on ressort si pas de fichier spcifi

    if {$nouveauFichier == "" } {
       msgInfo " Ouverture annule  votre demande."
       return
    } ; # fin si

    # on vrifie qu'il s'agit bien d'un fichier qui finit par .alg

    regexp {(.*)[.alg]} $nouveauFichier -> nomAlg
    if ![info exists nomAlg] {
       msgInfo " Impossible d'ouvrir $nouveauFichier : son nom ne finit pas par .alg."
       return
    } ; # fin si

    # on rajoute "g"  cause de regexp

    append nomAlg "g"

    set nouveauFichier [file tail $nomAlg]
    cd  [file dirname $nomAlg]
    set fichierAlg     $nouveauFichier
    set nomAlg     $nouveauFichier
    set fichierAlg $nomAlg

    # on a un nom de fichier, on ouvre

    voirFichier "alg"

} ; # fin proc ouvreFichier

# ********************************************************************************

proc reOuvreFichier { } { global etatF naturF

    set etatF 0
    # afficheEtat ""
    if { $naturF != "alg" } { return }
    voirFichier "alg"

} ; # fin proc reOuvreFichier

# ********************************************************************************

proc nouveauFichier {} { global fichierModifie fichierAlg .barreDeStatut.nomFichier verLang lstLang etatF nbErr

    # si modifi, on propose d'enregistrer

    set ancEtat [valEtat]
    if { [testeEnregistrer] == 1 } {
      msgInfo " le fichier courant n'est pas enregistr, cration d'un nouvel algorithme impossible."
      return
    } ; # finsi

    # par dfaut, on active le menu Insertion, on dsactive les menu Traductions et Excution

    menusAnalyse   "normal"
    menusInsertion "normal"
    menusTradExec "disabled"

    # on autorise les modifications dans l'diteur

    .editeur.texte configure -state normal

    # on efface le contenu courat de l'diteur

    .editeur.texte delete 1.0 end

    set fichierAlg "Nouvel algorithme"
    .barreDeStatut.nomFichier configure -text " $fichierAlg"

    afficheEtat ""
    set nbErr 0
    set etatF 0
    forceAncv  ; # pour ne pas affciher "modifi" en bas

} ; # fin proc nouveauFichier

# ********************************************************************************

proc proposeEnregistrer {} { global fichierAlg fichierModifie

  set titre    "Proposition de sauvegarde"
  set question "l'algorithme a t modifi.\nVoulez vous l'enregistrer ?"
  set choix [tk_dialog .dialogue $titre $question warning 0 Oui Non ] ; # 0 = oui, 1 = non
  if { $choix ==0 } { enregistrer }
  return $choix
} ; # fin proc proposeEnregistrer

# ********************************************************************************

proc enregistreFichier {} { global fichierAlg nomAlg

    if [catch {open $fichierAlg "w"} fichierId] {
       tk_dialog .erreurFichier "Erreur d'E/S" "Impossible d'ouvrir ou de crer $fichierAlg" error 0 Fermer
    } else {
      puts $fichierId [.editeur.texte get 0.0 end]
      close $fichierId
      set fichierModifie false
      afficheEtat ""
      .barreDeStatut.nomFichier configure -text " $fichierAlg"
      voirFichier "alg"
    } ; # fin si

} ; # fin proc enregistreFichier

# ********************************************************************************

proc enregistrerSous {} { global fichierAlg nomAlg

    set type { {{Algorithmes} {.alg}}}
    set nouveauFichier [tk_getSaveFile -title "Enregistrer sous" -filetypes $type]

    ecritDbg " nom du fichier = $nouveauFichier"
    regexp {(.*)[.](.*)} $nouveauFichier -> nomF typF
    if ![info exists typF] {
       set  nouveauFichier [string trim $nouveauFichier]
       set  nouveauFichier "$nouveauFichier.alg"
       ecritDbg " on complte en \"$nouveauFichier\" "
       regexp {(.*)[.](.*)} $nouveauFichier -> nomF typF
    } ; # fin si

    set fichierAlg $nouveauFichier
    set nomAlg     $nomF
    set naturF     "alg"
    enregistreFichier

} ; # fin proc enregistrerSous

# ********************************************************************************

proc enregistrer {} { global fichierAlg fichierModifie  nomAlg

    if { $fichierAlg =="Nouvel algorithme"} { # Permet de choisir un nom pour le fichier
        enregistrerSous
        return
    } ; # fin de si

    enregistreFichier

} ; # fin proc enregistrer

# *************************************************************************

proc quitter {} { global fichierModifie

    if {$fichierModifie=="true"} {
       set repSauve [proposeEnregistrer]
    } ; # fin de si
    finProg

} ; # fin proc quitter

# *************************************************************************
# *************************************************************************
# *                                                                       *
# *                              Analyse                                  *
# *                                                                       *
# *************************************************************************
# *************************************************************************

proc montreErreurs { txtErr } {

  regexp {ATTENTION :(.*)Copyright(.*)} $txtErr -> ligneErr
  set ligneErr_F ""
  if { [info exists ligneErr] } {
  set ligneErr "\n\n   ATTENTION :\n      $ligneErr"
  set longLigne [string length $ligneErr]
  set ligne ""
  for {set i 0} {$i < $longLigne } {incr i} {
      set charc [string index $ligneErr $i]
      if { $charc == "\n" } {
         append ligneErr_F "[surncarg $ligne 70]\n"
         set ligne ""
      } else {
        append ligne $charc
      } ; # fin si
  } ; # fin pour i
  if { [string length $ligne] > 0 } { append ligneErr_F "[surncarg $ligne 70]\n" }
  } else {
       set ligne " GALG a dtect des erreurs dans votre algorithme. "
       append ligneErr_F "[surncarg $ligne 70]\n"
  } ; # fin si
  return $ligneErr_F

} ; # fin proc montreErreurs

# *************************************************************************

proc analyser { } { global fichierModifie fichierAlg modeAff etatF nbErr nomOs

    set msgImp   "Impossible d'analyser un algorithme non sauvegard."
    set nbErr 0 ; # indicateur d'erreur

    if { $fichierAlg == "Nouvel algorithme"} {
        tk_messageBox -parent . -title "Avertissement" -message $msgImp -icon warning -type ok -default ok
        return
    } ; # fin si

    set msgNonVu "  GALG est introuvable ou GALG n'a pas pu ouvrir $fichierAlg  "
    set msgErr   "  GALG a dtect des erreurs dans votre algorithme   "
    set msgOk    "  GALG n'a dtect aucune erreur dans votre algorithme  "
    set msgAnnul "  Tant que le fichier n'est pas sauvegard, on ne peut pas lancer l'analyse.  "

    if {$fichierModifie=="true"} {
       set rep [proposeEnregistrer]
       if { $rep==1 } {
          tk_messageBox -parent . -title "Avertissement" -message $msgAnnul -icon warning -type ok -default ok
          return
       } ; # fin si rponse Non
    } ; # fin de si le fichier tait modifi

    # si on arrive ici, le fichier est sauvegard, on peut donc lancer l'analyse

    set cmdAna "galg -a $fichierAlg"
    if { $modeAff == "Dbutant" } { msgInfo "  excution de la commande : \n\n   $cmdAna\n\n" }
ecritDbg " excution de la commande : \n\n   $cmdAna\n\n"
    #  cause de l'valuation il faut doubler les \ de Windows

    set nfichierAlg ""
    set lonNfic     [string length $fichierAlg]
    if { $nomOs == "Windows" } {
       for {set i 0} {$i < $lonNfic} {incr i} {
           set charc [string index $fichierAlg $i]
           if { $charc == "\\" } { set charc "$charc$charc" }
           append nfichierAlg $charc
       } ; # fin pour i
        set nfichierAlg $fichierAlg
    } ; # finsi

    set nfichierAlg [file tail $fichierAlg]
    set cmdAna "galg -a $nfichierAlg"
ecritDbg " excution de la commande : \n\n   $cmdAna\n\n"

    if [catch {eval "exec $cmdAna"} res] {
ecritDbg "\n retour d'exec : $res \n"
         if {[regexp -nocase "Impossible d'ouvrir" res]==1} {
               tk_messageBox -parent . -title "Erreur"            -message $msgNonVu -icon error -type ok -default ok
               panoInfo " Rapport d'analyse" $res
         } else {
               set nbErr 1
               # set resAna [panoInfo "Rapport d'analyse" [montreErreurs $res]]
               tk_messageBox -parent . -title "Erreur"            -message $msgErr -icon error -type ok -default ok
         } ; # fin impossible
      } else {
         tk_messageBox -parent . -title "Rapport d'analyse" -message $msgOk    -icon info  -type ok -default ok
      } ; # finsi exec
      set etatF 1
      voirListing

} ; # fin proc analyser

# ********************************************************************************

proc activeAllerErreur { etatEr } {

    .menubar._Edition entryconfigure 1 -state $etatEr

} ; # fin proc activeAllerErreur
# ***************************************************************************************************
# *                                                                                                 *
# *                                     Traduction                                                  *
# *                                                                                                 *
# ***************************************************************************************************

proc traduire { langage } { global fichierAlg fichierModifie fichierTraduit lstLang extLang  modeAff langU etatF nbErr

  # rien  faire pour nouvel algorithme vide

  if { $fichierAlg == "Nouvel algorithme"} {
     if {$fichierModifie=="false"} {
         msgInfo " Mais il n'y a rien  traduire !"
         return
     } ; # fin de si
  } ; # fin de si

  # sans sauvegarde d'un algorithme modifi, pas de traduction

  if {$fichierModifie=="true"} {
     set propS [proposeEnregistrer]
     set msgAnnulTrad "Tant que le fichier n'est pas sauvegard, on ne peut pas traduire."
     if { $propS==1 } {
        tk_messageBox -parent . -title "Avertissement" -message $msgAnnulTrad -icon warning -type ok -default ok
        return
     } ; # fin si rponse Non
  } ; # fin de si le fichier tait modifi

  # pas de traduction pour un algorithme non analys

  if { $etatF < 1 } {
         msgInfo " Traduction impossible : vous n'avez pas analys votre algorithme."
         return
  } ; # fin de si

  # pas de traduction pour un algorithme analys et comportant des erreurs

  if { $nbErr > 0 } {
         msgInfo " Traduction impossible : vous avez des erreurs dans votre algorithme."
         return
  } ; # fin de si

  # si on arrive ici, on peut traduire

  set cmdTrad "galg -a $fichierAlg -o [string tolower $langage]"
  if { $modeAff == "Dbutant" } { msgInfo "  excution de la commande : \n\n $cmdTrad\n\n" }
  if [catch {eval "exec $cmdTrad"} res] {
     if {[regexp -nocase {"Imposible d'ouvrir"} res]==1} {
        tk_messageBox -parent . -title "Erreur" -message "GALG n'a pas pu ouvrir $fichierAlg" -icon error -type ok -default ok
      } else {
        tk_messageBox -parent . -title "Rapport d'analyse" -message "GALG a dtect des erreurs dans votre algorithme" -icon info -type ok -default ok
        voirListing
      }
  } else {
     regexp -nocase {(.*).alg} $fichierAlg -> nomFichier

     # on utilise extLang pour trouver l'extension du fichier

     set langU $langage
     set indExt  [lsearch -exact $lstLang $langage ]
     set extTrad [lindex $extLang $indExt]
     set fichierTraduit "$nomFichier.$extTrad"
     # tk_messageBox -parent . -title "Rapport d'analyse" -message "GALG n'a dtect aucune erreur dans votre algorithme"
     # -icon info -type ok -default ok
     set etatF 2
     voirTraduction
  } ; # fin si catch galg -a

} ; # fin  proc traduire

# ***************************************************************************************************
# *                                                                                                 *
# *                                         Excution                                               *
# *                                                                                                 *
# ***************************************************************************************************


proc parametresExec { } { global valParam

 # permet de dfinir les paramtres d'excution

 toplevel     .dialogue
 wm title     .dialogue "Saisie des paramtres d'excution"
 wm transient .dialogue .
 label        .dialogue.paramsLbl    -text "Paramtres"
 entry        .dialogue.paramsEntree -textvariable valParam -bg white
 grab         .dialogue
 focus        .dialogue.paramsEntree
 frame        .dialogue.boutonsFrame

 button .dialogue.boutonsFrame.valider -text Valider -default active -command {
        set valParam [.dialogue.paramsEntree get]
        grab release .dialogue
        focus        .editeur.texte
        destroy      .dialogue
 } ; # fin du bouton valider

 button .dialogue.boutonsFrame.vider -text vider -default active -command { set valParam "" }

 button .dialogue.boutonsFrame.annuler -text Annuler -command {
        grab release .dialogue
        focus        .editeur.texte
        destroy      .dialogue
 } ; # fin du bouton annuler

 pack .dialogue.paramsLbl .dialogue.paramsEntree .dialogue.boutonsFrame -pady 5 -fill x
 pack .dialogue.boutonsFrame.valider -side left
 pack .dialogue.boutonsFrame.vider   -side left
 pack .dialogue.boutonsFrame.annuler -side right
 bind .dialogue <Return> { .dialogue.boutonsFrame.valider invoke }

} ; # fin proc parametresExec

# ********************************************************************************

proc executer { langage } { global fichierAlg fichierModifie modeAff valParam etatF nomOs nbErr

  # rien  faire pour nouvel algorithme vide

  if { $fichierAlg == "Nouvel algorithme"} {
     if {$fichierModifie=="false"} {
         msgInfo " Mais il n'y a rien  excuter !"
         return
     } ; # fin de si
  } ; # fin de si

  # sans sauvegarde d'un algorithme modifi, pas de traduction

  if {$fichierAlg=="Nouvel algorithme"} {
     if {$fichierModifie=="true"} {
            tk_messageBox -parent . -title "Erreur" -message " Impossible d'excuter un algorithme non sauvegard. " -icon warning -type ok -default ok
            return
     } ; # fin si false
     enregistrerSous
     # L'utilisateur n'a pas sauv son algorithme, on ne peut pas le passer en paramtre  GALG
     if {$fichierAlg=="Nouvel algorithme"} {
            return
     } ; # fin si nouvel algorithme
  } elseif {$fichierModifie=="true"} {
            enregistrer
  } ; # fin si nouvel algo

  # pas d'excution pour un algorithme non analys

  if { $etatF < 1 } {
         msgInfo " Excution impossible : vous n'avez pas analys votre algorithme."
         return
  } ; # fin de si

  # pas d'excution pour un algorithme analys et comportant des erreurs

  if { $nbErr > 0 } {
         msgInfo " Excution impossible : vous avez des erreurs dans votre algorithme."
         return
  } ; # fin de si

  # pas d'excution pour un algorithme non traduit

  if { $etatF < 2 } {
         msgInfo " Excution impossible : vous n'avez pas traduit votre algorithme."
         return
  } ; # fin de si

  # arriv ici, on peut excuter en fonction du systme d'exploitation


  set cmd "galg -a \"$fichierAlg\" -o [string tolower $langage] -x $valParam"

  if { $modeAff == "Dbutant" } { msgInfo "  excution de la commande : \n\n $cmd\n\n" }

  if {$nomOs=="Linux"} {
        set script "$cmd\necho \"Appuyez sur la touche Entre...\"\nread\n"
        if [catch {open "runGalg.sh" "w"} res] {
              # Echec de la cration du script
              puts stderr "Impossible de gnrer le script pour excuter l'algorithme"
              return
        } else { # on peut crer le script
              puts $res $script
              close $res
              if [catch {exec xterm -e chmod +x runGalg.sh} res] {
                    puts stderr "Impossible de rendre le script excutable"
              }
              if [catch {exec xterm -e /bin/sh runGalg.sh} res] {
                    puts stderr "Impossible d'ouvrir un terminal afin d'excuter l'algorithme"
              } else {
                    voirListing
              }
        }
  } else { # ce doit etre Windows
        set script "call $cmd\r\npause\r\npause\r\n"
        if [catch {open "runGalg.bat" "w"} res] {
           # Echec de la cration du script
           puts stderr "Impossible de gnrer le script pour excuter l'algorithme"
           return
        } else {  # on peut crer le script
           puts $res $script
           close $res
           if [catch {exec CMD /C runGalg.bat} res] {
           puts stderr "Impossible d'ouvrir un terminal afin d'excuter l'algorithme"
        } else {
           voirTraduction

        }

        }
  } ; # fin si sur nomOs

} ; # fin  proc  executer

# *******************************************************************************************************
# *******************************************************************************************************
# *                                                                                                     *
# *                                           Edition                                                   *
# *                                                                                                     *
# *******************************************************************************************************
# *******************************************************************************************************

proc premiereErreur {} { global fichierAlg nbErr etatF

 # si fichier non analys, on repart

 if { $etatF == 0 } {
       msgInfo  " Impossible, vous n'avez pas analys votre algorithme. "
       return
 } ; # fin si

 # si fichier non analys sans erreur, on le dit

 if { $nbErr == 0 } {
    msgInfo " Aucune erreur dtecte."
    return
 } ; # fin si

 # on lit le listing pour trouver l'erreur

 voirListing
 set buffer [.editeur.texte get 0.0 end]
 regexp -nocase {\*\*\*[ ]*([0-9]+)} $buffer -> ligne

 # on vrifie qu'il existe une erreur

 if [info exists ligne] {

            # le numro de ligne est peut-tre 00x : on enlve donc les 0 de tte
            msgInfo " erreur en ligne : $ligne "
            while { [string index $ligne 0] == "0" } { set ligne [string range $ligne 1 end ] }
            msgInfo " filtre en erreur en ligne : $ligne "

            voirAlgo
            .editeur.texte see $ligne.0
            .editeur.texte mark set insert $ligne.0
            # Mise en vidence de la ligne
            .editeur.texte tag bind tag_surbrillance <Any-Enter> {.editeur.texte tag delete tag_surbrillance}
            .editeur.texte tag configure tag_surbrillance -relief raised -borderwidth 1 -background red
            .editeur.texte tag add tag_surbrillance $ligne.0 "$ligne.0 lineend"

 } ; # fin si ligne d'erreur

} ; # fin  proc premiereErreur

# ********************************************************************************

proc allerALaLigne {} {  global .editeur.texte  ligneNo  tag_surbrillance

    regexp {(.*)[.](.*)} [.editeur.texte index end] -> ligneNo colonneNo
    toplevel     .dialogue
    wm title     .dialogue "Aller  la ligne n"
    wm transient .dialogue .
    label        .dialogue.ligneLbl -text "Numro de la ligne (1 - $ligneNo)"
    entry        .dialogue.ligneEntree -bg white -width 30
    frame        .dialogue.boutonsFrame

    button  .dialogue.boutonsFrame.valider -text Valider -command {
             set saisie [.dialogue.ligneEntree get]
             if {$saisie!=""} {
                   if {$saisie<= $ligneNo} {
                        .editeur.texte see $saisie.0
                        .editeur.texte mark set insert $saisie.0
                        # Mise en vidence de la ligne
                        .editeur.texte tag bind tag_surbrillance <Any-Enter> {.editeur.texte tag delete tag_surbrillance}
                        .editeur.texte tag configure tag_surbrillance -relief raised -borderwidth 1 -background blue
                        .editeur.texte tag add tag_surbrillance $saisie.0 "$saisie.0 lineend"
                        grab release .dialogue
                        focus .editeur.texte
                        destroy .dialogue
                  } else {
                        tk_messageBox -title "Erreur de saisie" -icon error -type ok -message "Valeur invalide"
                  }
            }
    }

    button .dialogue.boutonsFrame.annuler -text Annuler -command {
       grab release .dialogue
       focus .editeur.texte
       destroy .dialogue
    } ; # fin annuler

    pack  .dialogue.ligneLbl .dialogue.ligneEntree .dialogue.boutonsFrame -pady 2 -fill x
    pack  .dialogue.boutonsFrame.valider -pady 5 -side left
    pack  .dialogue.boutonsFrame.annuler -pady 5   -side right
    grab  .dialogue
    focus .dialogue.ligneEntree
    bind  .dialogue <Return> {.dialogue.boutonsFrame.valider invoke ; break}
    bind  .dialogue <Escape> {.dialogue.boutonsFrame.annuler invoke ; break}

} ; # fin  proc allerALaLigne

# ********************************************************************************

proc detruitLigne { } { global naturF

# si ce n'est pas l'algorithme, on sort discrtement

if { $naturF != "alg" } { return }

# on calcule les numros de ligne et on dtruit

regexp {(.*)[.](.*)} [.editeur.texte index insert] -> ligneNo colonneNo
.editeur.texte delete "$ligneNo.0" "[expr 1 +$ligneNo].0"

} ; # fin  proc allerALaLigne

# ********************************************************************************


# *******************************************************************************************************
# *                                                                                                     *
# *                                           Insertion                                                 *
# *                                                                                                     *
# *******************************************************************************************************

proc copies { itm rep } {

  set chen ""
  for {set i 1} {$i <= $rep} {incr i} {
      append chen $itm
  } ; # fin pour i
  return $chen

} ; #proc copies

# ********************************************************************************

proc getInsertion { } { global prmIns nbParm

  regexp {(.*)[.](.*)} [.editeur.texte index insert] -> posLigne posColonne

  set lins [string trim $prmIns(3)]
  set sinon 0
  if { $lins == "SINON"       } {
     set sinon 1
     set lins "SI"
  } ; # finsi
  .editeur.texte insert insert "$lins [.dialogue.ent1 get] $prmIns(4)[copies " " $posColonne]"
  if { $lins == "SI"       } {
     if { $sinon == 0 } {
       .editeur.texte insert insert "   ALORS\n\n[copies " "  $posColonne]"
     } else {
       .editeur.texte insert insert "   ALORS\n[copies " "  $posColonne]"
       .editeur.texte insert insert "\n[copies " "  $posColonne]   SINON\n[copies " "  $posColonne]\n[copies " "  $posColonne]"
     } ; # finsi
  } ; # finsi
  if { $nbParm >=  7 } { .editeur.texte insert insert " $prmIns(6) [.dialogue.ent2 get] $prmIns(7)[copies " " $posColonne]" }
  if { $nbParm >= 10 } { .editeur.texte insert insert " $prmIns(9) [.dialogue.ent3 get] $prmIns(10)[copies " " $posColonne]" }

  if { [lsearch -exact "SI POUR TANT_QUE" $lins] > -1 } {

     if { $lins == "SI"       } { set posx 2 ; set posy  5 }
     if { $lins == "POUR"     } { set posx 1 ; set posy  5 }
     if { $lins == "TANT_QUE" } { set posx 1 ; set posy  5 }
     if { $sinon == 0 }         { set posy 3 }

     # fin de l'instruction

      .editeur.texte insert insert "FIN_$prmIns(3) # [.dialogue.ent1 get]"

     # on se repositionne   l'intrieur de la structure

     set nposColonne [expr $posy+$posColonne]
     set    txtAins [copies " " $nposColonne]
# append    txtAins "a"
     set nposLigne [expr $posx+$posLigne]
     .editeur.texte see $nposLigne.$nposColonne
     .editeur.texte mark set insert $nposLigne.$nposColonne
     .editeur.texte insert insert $txtAins

  } ; # fin si

  grab release .dialogue
  focus        .editeur.texte
  destroy      .dialogue
  finInsertion

} ; # fin proc getInsertion

# ********************************************************************************

proc finInsertion { } {

    majNums
    set fichierModifie true
    afficheEtat "modifi"

} ; # proc finInsertion

# ********************************************************************************

proc insereInstruction { nbParmI } { #  on insre l'instruction  l'emplacement du symbole d'insertion

    global prmIns nbParm

    set nbParm $nbParmI
    toplevel     .dialogue
    wm title     .dialogue $prmIns(1)
    wm transient .dialogue .
    grab         .dialogue
    label        .dialogue.lab1 -text $prmIns(2)
    entry        .dialogue.ent1 -bg white

    if { $nbParmI >= 7 } {
       label  .dialogue.lab2 -text $prmIns(5)
       entry  .dialogue.ent2 -bg white
    } ; # fin si

    if { $nbParmI >= 10 } {
       label  .dialogue.lab3 -text $prmIns(8)
       entry  .dialogue.ent3 -bg white
    } ; # fin si

    focus  .dialogue.ent1
    frame  .dialogue.boutonsFrame

    button .dialogue.boutonsFrame.valider -text Valider -default active -command {  getInsertion }

    button .dialogue.boutonsFrame.annuler -text Annuler -command {
            finInsertion
            grab release .dialogue
            focus        .editeur.texte
            destroy      .dialogue
    } ; # fin bouton annuler

    set debPack    "pack .dialogue.lab1 .dialogue.ent1 "
    if { $nbParmI >=  7 } {  append debPack "  .dialogue.lab2 .dialogue.ent2 " }
    if { $nbParmI >= 10 } {  append debPack "  .dialogue.lab3 .dialogue.ent3 " }
    append debPack "     .dialogue.boutonsFrame -side top -fill x "
    eval $debPack
    pack .dialogue.lab1 -padx 30 -pady 10
    pack .dialogue.ent1 -pady 2

    if { $nbParmI >= 7 } {
       pack .dialogue.lab2 -padx 30 -pady 10
       pack .dialogue.ent2 -pady 2
    } ; # fin si

    if { $nbParmI >= 10 } {
       pack .dialogue.lab3 -padx 30 -pady 10
       pack .dialogue.ent3 -pady 2
    } ; # fin si

    pack .dialogue.boutonsFrame -pady 5
    pack .dialogue.boutonsFrame.valider -side left
    pack .dialogue.boutonsFrame.annuler -side right
    bind .dialogue <Return> {  .dialogue.boutonsFrame.valider invoke  }
    bind .dialogue <Escape> {  .dialogue.boutonsFrame.annuler invoke  }

} ; # fin proc insereInstruction

# ********************************************************************************

proc insereCommentaire {} { global prmIns

    set prmIns(1)  "Insertion d'un commentaire"
    set prmIns(2)  "Texte du commentaire"
    set prmIns(3)  "# "
    set prmIns(4)  "\n"
    insereInstruction 4

} ; # fin  proc insereCommentaire

# ********************************************************************************

proc insereAuteur {} { global prmIns

    set prmIns(1)  "Insertion d'un nom d'auteur"
    set prmIns(2)  "Auteur :"
    set prmIns(3)  "# auteur : "
    set prmIns(4)  "\n"
    insereInstruction 4

} ; # fin  proc insereAuteur

# ********************************************************************************

proc insereLire {} { global prmIns

    set prmIns(1)  "Insertion de \"LIRE\" "
    set prmIns(2)  "Instruction LIRE "
    set prmIns(3)  "LIRE "
    set prmIns(4)  "\n"
    insereInstruction 4

} ; # fin  proc insereLire

# ********************************************************************************

proc insereEcrire {} { global prmIns

    set prmIns(1)  "Insertion de \"ECRIRE\" "
    set prmIns(2)  "Instruction ECRIRE "
    set prmIns(3)  "ECRIRE "
    set prmIns(4)  "\n"
    insereInstruction 4

} ; # fin  proc insereEcrire

# ********************************************************************************

proc insereOuvrirFichierEnLecture {} { global prmIns

    set prmIns(1)  "Insertion de \"OUVRIR Fichier\" "
    set prmIns(2)  " nom du Fichier (ou variable chaine)"
    set prmIns(3)  "OUVRIR "
    set prmIns(4)  " EN_LECTURE "
    set prmIns(5)  " variable-Fichier "
    set prmIns(6)  " COMME "
    set prmIns(7)  "\n"
    insereInstruction 7

} ; # fin  proc insereOuvrirFichierEnLecture

# ********************************************************************************

proc insereOuvrirFichierEnEcriture {} { global prmIns

    set prmIns(1)  "Insertion de \"OUVRIR Fichier\" "
    set prmIns(2)  " nom du Fichier (ou variable chaine)"
    set prmIns(3)  "OUVRIR "
    set prmIns(4)  " EN_ECRITURE "
    set prmIns(5)  " variable-Fichier "
    set prmIns(6)  " COMME "
    set prmIns(7)  "\n"
    insereInstruction 7

} ; # fin  proc insereOuvrirFichierEnEcriture

# ********************************************************************************

proc insereLiresurFichier {} { global prmIns

    set prmIns(1)  "Insertion de \"LIRE SUR\" "
    set prmIns(2)  "Instruction LIRE "
    set prmIns(3)  "LIRE "
    set prmIns(4)  ""
    set prmIns(5)  " variable-Fichier "
    set prmIns(6)  " SUR "
    set prmIns(7)  "\n"
    insereInstruction 7

} ; # fin proc insereLiresurFichier

# ********************************************************************************

proc insereEcriresurFichier {} { global prmIns

    set prmIns(1)  "Insertion de \"ECRIRE SUR\" "
    set prmIns(2)  "Instruction ECRIRE "
    set prmIns(3)  "ECRIRE "
    set prmIns(4)  ""
    set prmIns(5)  " variable-Fichier "
    set prmIns(6)  " SUR "
    set prmIns(7)  "\n"
    insereInstruction 7

} ; # fin proc insereEcriresurFichier

# ********************************************************************************

proc insereFermerFichier {} { global prmIns

    set prmIns(1)  "Insertion de \"FERMER Fichier\" "
    set prmIns(2)  " variable-Fichier "
    set prmIns(3)  "FERMER "
    set prmIns(4)  "\n"
    insereInstruction 4

} ; # fin  proc insereEcrire

# ********************************************************************************

proc insereAffectation {} { global prmIns

    set prmIns(1)  "Insertion de \"AFFECTER\" "
    set prmIns(2)  " valeur                 "
    set prmIns(3)  "AFFECTER "
    set prmIns(4)  ""
    set prmIns(5)  " expression   affecter "
    set prmIns(6)  " <-- "
    set prmIns(7)  "\n"
    insereInstruction 7

} ; # fin proc insereAffectation

# ********************************************************************************

proc insereBouclePour {} { global prmIns

    set prmIns(1)  "Insertion d'une boucle \"POUR\" "
    set prmIns(2)  " variable de boucle     "
    set prmIns(3)  "POUR "
    set prmIns(4)  ""
    set prmIns(5)  " valeur initiale "
    set prmIns(6)  " DE "
    set prmIns(7)  ""
    set prmIns(8)  " valeur finale "
    set prmIns(9)  " A "
    set prmIns(10) "\n\n"
    insereInstruction 10

} ; # fin  proc insereBouclePour

# ********************************************************************************

proc insereSi { } { global prmIns

    set prmIns(1)  "Insertion d'un test en \"SI\" alors"
    set prmIns(2)  " condition   "
    set prmIns(3)  "SI "
    set prmIns(4)  "\n"
    insereInstruction 4

} ; # fin  proc insereSi

# ********************************************************************************

proc insereSinon { } { global prmIns

    set prmIns(1)  "Insertion d'un test en \"SI\" alors sinon"
    set prmIns(2)  " condition   "
    set prmIns(3)  "SINON "
    set prmIns(4)  "\n"
    insereInstruction 4

} ; # fin  proc insereSinon

# ********************************************************************************

proc insereTantQue { } { global prmIns

    set prmIns(1)  "Insertion d'un test en \"TANT QUE\" "
    set prmIns(2)  " condition   "
    set prmIns(3)  "TANT_QUE "
    set prmIns(4)  "\n\n"
    insereInstruction 4

} ; # fin  proc insereTantque

# ********************************************************************************
# ********************************************************************************
# *                                                                              *
# *                                        Aide                                  *
# *                                                                              *
# ********************************************************************************
# ********************************************************************************

proc langagesSupportes {} { global lstLang runLang

 set    txtLs "\n\n[surncarg "  Voici la liste des langages supports par Galg" 70]"
 append txtLs "\n[surncarg "  (avec leur commande d'excution)" 70]\n\n"
 foreach lang $lstLang  { # attention : galg est mis dans la liste des langages
   if {$lang!="Galg"} {
      append txtLs "[surncarg "         -   $lang "        20] : "
      append txtLs "[surncarg "   $runLang("$lang")"        47]\n"
   } ; # fin si
 } ; # fin de pour chaque langage
 set       msgLs " Langages supports par galg "
 panoInfo $msgLs $txtLs

} ; # fin proc langagesSupportes

# ********************************************************************************

proc langagesPresents {} {  global verLang lstLang cmdLang

 set txtLangp ""
 append txtLangp "\n\n[surncarg "   Les langages suivants ont t trouvs" 70]\n"
 append txtLangp "[surncarg "   (avec leur commande de dtection)" 70]\n\n"
 set nbLang 0
 foreach lang $lstLang  {
   if {$lang!="Galg"} {  # attention : galg est mis dans la liste des langages
      if { [string toupper $verLang("$lang")] !="ABSENT"} {
         set    dscLang "     [string range " $lang         " 0 7]"
         append dscLang "  [surncarg "$verLang("$lang")" 15]"
         append dscLang "  :  $cmdLang("$lang")"
         append txtLangp "[surncarg $dscLang 70]\n"
         set nbLang [incr nbLang]
      } ; # fin de si sur version
   } ; # fin de si sur lang=galg
 } ; # fin de pour chaque langage
 if { $nbLang == 0 } { append txtLangp "\n[surncarg "          (aucun)  " 70]\n" }

 append txtLangp "\n\n[surncarg "   Langages non trouvs avec leur commande de dtection " 70]\n\n"
 set nbLang 0
 foreach lang $lstLang  {
   if {$lang!="Galg"} {  # attention : galg est mis dans la liste des langages
      if { [string toupper $verLang("$lang")] =="ABSENT"} {
         set    dscLang  "     [string range " $lang         " 0 7]"
         append dscLang  "   :   $cmdLang("$lang")"
         append txtLangp "[surncarg $dscLang 70]\n"
         set nbLang [incr nbLang]
      } ; # fin de si sur version
   } ; # fin de si sur lang=galg
 } ; # fin de pour chaque langage
 if { $nbLang == 0 } { append txtLangp "\n[surncarg "          (aucun)  " 70]\n" }

  set msgLangp "Langages dtects comme prsents sur votre machine"
  panoInfo $msgLangp $txtLangp

} ; # proc langagesPresents

# ********************************************************************************

proc surncarg { chen long } {

  set nchen $chen
  while { [string length $nchen] < $long } {
      append nchen " "
  } ; # fin tant que
  return $nchen

} ; # fin proc surncarg

# ********************************************************************************

proc aideWeb { } { # page d'aide sur le web

  global nomOs nomBrowser  galgUrl

  # il n'est pas sur qu'on puisse accder  la page Web, alors
  # on indique de quelle page il s'agit

  set galgUrl  "http://www.info.univ-angers.fr/pub/gh/Galg/galg.htm"
  set    msgAide ""
  append msgAide "\n   Si votre navigateur ne se lance pas automatiquement, consultez    \n"

  # tk_messageBox  -title "Site web de galg" -message $msgAide -parent . -icon info -type ok

  toplevel     .dialogue
  wm title     .dialogue "Aide sur GALG"
  wm transient .dialogue .
  focus        .dialogue
  label        .dialogue.msgLbl -text $msgAide
  entry        .dialogue.url -bg white -width 50
  label        .dialogue.videLbl1 -text ""
  frame        .dialogue.boutons
  button       .dialogue.boutons.lancer -text "lancer " -command lancerAideWeb
  button       .dialogue.boutons.fermer -text "Fermer " -command { destroy .dialogue }
  label        .dialogue.videLbl2 -text ""
  pack         .dialogue.boutons.lancer .dialogue.boutons.fermer  -pady 5 -side left
  pack         .dialogue.msgLbl .dialogue.url .dialogue.videLbl1 .dialogue.boutons .dialogue.videLbl2
  focus        .dialogue.boutons.lancer
  .dialogue.url insert insert "   $galgUrl   "

} ; # fin proc aideWeb

# ********************************************************************************

proc lancerAideWeb { } {

  global nomOs nomBrowser galgUrl

  if {$nomOs=="Linux"} {
     if [info exists nomBrowser] {
        # tk_messageBox  -title "Site web de galg" -message "$nomBrowser $galgUrl &"  -parent . -icon info -type ok
        catch { eval exec "$nomBrowser  $galgUrl &" } resExec
     } ; # fin de si le browser est dfini
  } ; # fin de si on est sous Linux

  if {$nomOs=="Windows"} {
     if [info exists nomBrowser] {
        catch { exec $nomBrowser $galgUrl } resExec
     }
  } ; # fin de si on est sous Windows

  focus   .editeur.texte
  destroy .dialogue

} ; # fin proc  lancerAideWeb

# ********************************************************************************

proc aPropos {} {  global verLang nomOs

 set    msg "\n[surncarg "        Interface en Tcl/Tk sous $nomOs pour GALG" 70]\n\n" ;
 append msg "\n[surncarg "        Initialement ralise par Sophie TRAN et Romain LEVY," 70]\n"
 append msg "reprise par (gH) -- Gilles HUNAULT\n\n"

 if { [string toupper $verLang("Perl")] !="ABSENT"} {
    if { [string toupper $verLang("Galg")] !="ABSENT"} {
        set    fmsg "[surncarg "        Perl $verLang("Perl") dtect" 70]\n"
        append fmsg "[surncarg "        GALG $verLang("Galg") dtect" 70]\n"
    } else {
        set    fmsg "[surncarg "        Perl $verLang("Perl") dtect" 70]\n"
        append fmsg "[surncarg "        GALG non dtect      " 70]"
    }
 } else {
    set    fmsg "[surncarg "        Perl non dtect" 70]\n"
    append fmsg "[surncarg "        GALG non dtect" 70]"
 } ; # fin de si
 append msg $fmsg

 panoInfo "A propos de galg.tcl" "$msg\n\n"

} ; # fin proc aPropos

# ********************************************************************************

proc finProg { } {

 puts stdout "\n -- fin de galg.tcl\n\n"
 exit

} ; # fin de proc Finprog

# *****************************************************************
# *                                                               *
# *   Exemples standards                                          *
# *                                                               *
# *****************************************************************

proc exemple { nomXmp } { global fichierAlg naturF etatF

ecritDbg  " proc exemple $nomXmp "

set lstXmp "bonjour  secondes  tabmult  cfe  maxocc  brutese  glouton  trifus  creedic"
   set posNb [lsearch -exact "1 2 3 4 5 6 7 8 9" $nomXmp]
   if { $posNb > -1 } {
      set nbXmp [lindex $lstXmp $posNb]
      set nomXmp $nbXmp
   } ; # fin si c'est un nombre

set  nomAlg $nomXmp
set  algXmp "$nomXmp.alg"
set  ficXmp [open $algXmp "w"]
set naturF "alg"

switch -exact -- $nomXmp {

"bonjour" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "#  auteur : (gH)                                       #"
puts $ficXmp "#  bonjour.alg : un algorithme de bonjour              #"
puts $ficXmp "#                (avec dialogue et appels systmes)    #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp ""
puts $ficXmp "   # la demande = une question + une rponse"
puts $ficXmp ""
puts $ficXmp "   crire   \" Bonjour. Quel est ton nom ? \" "
puts $ficXmp "   lire     id"
puts $ficXmp ""
puts $ficXmp "   # ce qu'on fait rpondre par la machine"
puts $ficXmp ""
puts $ficXmp "   crire   \" Le \", date(), \"  \", heure(), \" au revoir \" , maju(id)"
puts $ficXmp ""
puts $ficXmp ""

} ; # fin de l'exemple bonjour

"secondes" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "#  auteur : (gH)                                       #"
puts $ficXmp "#  secondes.alg : nombre de secondes coules          #"
puts $ficXmp "#                 entre l'an 0 et l'an 2000            #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp ""
puts $ficXmp "   affecter   an        <-- 2000  # en l'an 2000 "
puts $ficXmp "   affecter   nbAnBi    <-- an/4  # nombre d'annes bissextiles (2000/4)"
puts $ficXmp "   affecter   nbJours   <-- (an*365) + nbAnBi"
puts $ficXmp "   affecter   nbHeur    <-- nbJours * 24"
puts $ficXmp "   affecter   nbSec     <-- (nbHeur*60)* 60"
puts $ficXmp ""
puts $ficXmp "   crire \"Entre l'an 0 et l'an \" , an , \" il s'est coul \" , nbSec , \" secondes.\" "
puts $ficXmp ""
puts $ficXmp ""

} ; # fin de l'exemple bonjour

"tabmult" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "#  auteur : (gH)                                       #"
puts $ficXmp "#  tabmult.alg : la table de multiplication            #"
puts $ficXmp "#                avec entre controle                 #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp ""
puts $ficXmp ""
puts $ficXmp "   # demande initiale"
puts $ficXmp "   "
puts $ficXmp "   crire  \" Donner un entier compris entre 1 et 100 \""
puts $ficXmp "   lire nbChoisi"
puts $ficXmp "   "
puts $ficXmp "   # relance ventuelle"
puts $ficXmp "   "
puts $ficXmp "   tant_que (non entier(nbChoisi))"
puts $ficXmp "       crire \" nombre incorrect. Redonner un nombre ENTIER \""
puts $ficXmp "       lire nbChoisi"
puts $ficXmp "   fin_tant_que # nombre invalide"
puts $ficXmp "   "
puts $ficXmp "   # boucle d'affichage"
puts $ficXmp "   "
puts $ficXmp "   crire \" Table de \" , nbChoisi"
puts $ficXmp "   pour indb de1a 10"
puts $ficXmp "       affecter produit <-- nbChoisi*indb"
puts $ficXmp "       affecter find    <-- formatEntier(indb,2,0)"
puts $ficXmp "       affecter fpro    <-- formatEntier(produit,5,0)"
puts $ficXmp "       crire find , \" fois \" , nbChoisi , \" = \" , fpro"
puts $ficXmp "   fin_pour # indb de1a 10"
puts $ficXmp ""
puts $ficXmp ""

} ; # fin de l'exemple tabmult

"cfe" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "# cfe.alg  ;  conversion de francs vers euros          #"
puts $ficXmp "#          -- auteur : gh                              #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp "   # 1. Saisie ou conversion du paramtre"
puts $ficXmp "   "
puts $ficXmp "   si _nbParametres()=0"
puts $ficXmp "      alors crire   \" Quel est le montant en Francs ? \""
puts $ficXmp "            lire     mntF"
puts $ficXmp "      sinon affecter mntF <-- _valeur( _parametre( 1 ) )"
puts $ficXmp "   fin_si # nbParametres()=0"
puts $ficXmp "   "
puts $ficXmp "   # 2. Conversion et affichage"
puts $ficXmp "   "
puts $ficXmp "   affecter mntE <-- mntF / 6.55957"
puts $ficXmp "   crire   mntF , \" Francs font \" , mntE , \" euros.\""
puts $ficXmp "   crire   \" et si on arrondit : \" , _partieEntiere( 0.5+mntE ), \" euros.\" "
puts $ficXmp "   "
puts $ficXmp ""

} ; # fin de l'exemple cfe

"maxocc" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "#  maxocc.alg : comptage des occurences du maximum     #"
puts $ficXmp "#               d'un tableau en une seule boucle       #"
puts $ficXmp "#                                                      #"
puts $ficXmp "#  -- auteur  : gh                                     #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp "   # initialisation du tableau avec 15 lments"
puts $ficXmp "   # entiers entre 10 et 100"
puts $ficXmp "   "
puts $ficXmp "   "
puts $ficXmp "   affecter nbElt <-- 15"
puts $ficXmp "   appeler init_Tab( monT , nbElt , 10 , 20 )"
puts $ficXmp "   "
puts $ficXmp "   # dtermination du max et comptage du nb d'occurences"
puts $ficXmp "   # du max en une seule boucle"
puts $ficXmp "   "
puts $ficXmp "   # initialisation de la valeur du maximum (valMax)"
puts $ficXmp "   # et de son nombre d'occurences (nbMax)"
puts $ficXmp "   "
puts $ficXmp "   affecter valMax  <-- monT\[ nbElt \]"
puts $ficXmp "   affecter nbMax   <-- 1"
puts $ficXmp "   "
puts $ficXmp "   # on parcourt alors le tableau"
puts $ficXmp "   # sans utiliser le dernier lment dja comptabilis"
puts $ficXmp "   "
puts $ficXmp "   pour indb de1a nbElt-1"
puts $ficXmp "        affecter eltCourant <-- monT\[ indb \]"
puts $ficXmp "        si eltCourant > valMax"
puts $ficXmp "           alors # nouveau maximum local"
puts $ficXmp "                 affecter valMax  <-- eltCourant"
puts $ficXmp "                 affecter nbMax   <-- 1"
puts $ficXmp "           sinon"
puts $ficXmp "                 si eltCourant = valMax"
puts $ficXmp "                    alors # une fois de plus le maximum"
puts $ficXmp "                          affecter nbMax <-- nbMax + 1 "
puts $ficXmp "                 fin_si # nouvelle occurence du maximum "
puts $ficXmp "        fin_si # nouveau maximum"
puts $ficXmp "   fin_pour # indb de1a 10"
puts $ficXmp "   "
puts $ficXmp "   # affichage de fin"
puts $ficXmp "   "
puts $ficXmp "   crire \" Le maximum dans le tableau est : \" , valMax"
puts $ficXmp "   crire \" et il apparait \" , nbMax , \" fois.\""
puts $ficXmp "   crire \" Pour vrification, voici les lments du tableau : \""
puts $ficXmp "   "
puts $ficXmp "   appeler affiche_Tab( monT , 1 , nbElt , 4)"
puts $ficXmp ""
puts $ficXmp ""

} ; # fin de l'exemple maxoccr

"brutese" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "#   brutese.alg : brutesearch, auteur (gH)             #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "# source : Algorithms, second edition                  #"
puts $ficXmp "#          pages 279, 280                              #"
puts $ficXmp "#          R. Sedgewick, Addison-Wesley 1988           #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "#  recherche \"brute\" du tableau P dans le tableau A  #"
puts $ficXmp "#  (en anglais : P pour pattern, A pour array)         #"
puts $ficXmp "#  les variables sont renommes tabP et tabA           #"
puts $ficXmp "#  pour plus de lisibilit                             #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp "   affecter chP <--  \"STING\" "
puts $ficXmp "   affecter chA <--  \"A STRING SEARCHING EXAMPLE CONSISTING OF...\""
puts $ficXmp "   "
puts $ficXmp "   # conversion des chaines en tableau"
puts $ficXmp "   "
puts $ficXmp "   affecter M <-- _longueur(chP)"
puts $ficXmp "   pour ind de1a M"
puts $ficXmp "     affecter tabP\[ ind \] <--  _codeAscii( _sousChaine(chP,ind,1) )"
puts $ficXmp "   fin_pour # ind de1a _longueur(chP)"
puts $ficXmp "   "
puts $ficXmp "   affecter N <-- _longueur(chA)"
puts $ficXmp "   pour ind de1a N"
puts $ficXmp "     affecter tabA\[ ind \] <--  _codeAscii(_sousChaine(chA,ind,1) )"
puts $ficXmp "   fin_pour # ind de1a _longueur(chA)"
puts $ficXmp "   "
puts $ficXmp "   # algorithme de recherche"
puts $ficXmp "   "
puts $ficXmp "   affecter i <-- 1"
puts $ficXmp "   affecter j <-- 1 "
puts $ficXmp "   "
puts $ficXmp "   rpter"
puts $ficXmp "   "
puts $ficXmp "     si tabA\[i\] = tabP\[j\]"
puts $ficXmp "        alors "
puts $ficXmp "              affecter i <-- i + 1"
puts $ficXmp "              affecter j <-- j + 1"
puts $ficXmp "        sinon"
puts $ficXmp "              affecter i <-- i - j + 2"
puts $ficXmp "              affecter j <-- 1"
puts $ficXmp "     fin_si # tabA\[i\] = tabP\[i\]"
puts $ficXmp "   "
puts $ficXmp "   jusqu' (j>M) ou (i>N)"
puts $ficXmp "   "
puts $ficXmp "   # affichage du rsultat"
puts $ficXmp "   "
puts $ficXmp "   si j>M"
puts $ficXmp "      alors "
puts $ficXmp "            crire chP , \" vue dans \" , chA , \"  partir de la position \" , i-M"
puts $ficXmp "      sinon "
puts $ficXmp "            crire chP , \" non vue dans \", chA"
puts $ficXmp "   fin_si # j>M"
puts $ficXmp "   "
puts $ficXmp "   # dtail des tableaux (on suppose M < N)"
puts $ficXmp "   "
puts $ficXmp "   crire \" Elment   tableau P         tableau A \""
puts $ficXmp "   pour ind de1a N"
puts $ficXmp "       si (ind<=M)"
puts $ficXmp "          alors "
puts $ficXmp "                crire format(ind,3) , \" : \" , format(tabP\[ind\],8) , format(tabA\[ind\],8)"
puts $ficXmp "          sinon "
puts $ficXmp "                crire format(ind,3) , \" : \" , copies(\" \",8)   ,   format(tabA\[ind\],8)"
puts $ficXmp "       fin_si # (ind<=M)"
puts $ficXmp "   fin_pour # ind de1a max( N,M)"
puts $ficXmp ""
puts $ficXmp ""

} ; # fin de l'exemple brutese

"glouton" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "# glouton.alg : affectation de taches selon            #"
puts $ficXmp "#               la mthode de mac Naughton             #"
puts $ficXmp "# -- auteur (gH)                                       #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp "   affecter nbMachines  <-- 3"
puts $ficXmp "   affecter nbTaches    <-- 6"
puts $ficXmp "   "
puts $ficXmp "   affecter dureeTache\[ 1 \]  <--   5"
puts $ficXmp "   affecter dureeTache\[ 2 \]  <--   3"
puts $ficXmp "   affecter dureeTache\[ 3 \]  <--   4"
puts $ficXmp "   affecter dureeTache\[ 4 \]  <--   5"
puts $ficXmp "   affecter dureeTache\[ 5 \]  <--   2"
puts $ficXmp "   affecter dureeTache\[ 6 \]  <--   5"
puts $ficXmp "   "
puts $ficXmp "   "
puts $ficXmp "   # 1. Calcul de la dure minimale"
puts $ficXmp "   "
puts $ficXmp "   affecter somDuree <-- 0"
puts $ficXmp "   pour indTache de1a nbTaches"
puts $ficXmp "        affecter dureeCour <-- dureeTache\[ indTache \]"
puts $ficXmp "        affecter somDuree  <-- somDuree + dureeCour    "
puts $ficXmp "        si indTache=1"
puts $ficXmp "           alors affecter dureeMax <-- dureeCour"
puts $ficXmp "           sinon"
puts $ficXmp "                 si dureeCour > dureeMax"
puts $ficXmp "                    alors affecter dureeMax <-- dureeCour"
puts $ficXmp "                 fin_si # dureeCour > dureeMAx"
puts $ficXmp "        fin_si # indTache=1"
puts $ficXmp "   fin_pour # indTache de1a nbTaches"
puts $ficXmp "   affecter dureeMin <-- max( somDuree / nbMachines , dureeMax)"
puts $ficXmp "   "
puts $ficXmp "   crire \" la dure minimale est \" , dureeMin ,\" heures.\""
puts $ficXmp "   "
puts $ficXmp "   # 2. Affectation des taches aux machines"
puts $ficXmp "   "
puts $ficXmp "   # 2.1 Initialisation du tableau de rpartititon"
puts $ficXmp "   "
puts $ficXmp "   pour indTache de1a nbTaches"
puts $ficXmp "        affecter nbTache\[ indTache \] <-- 0"
puts $ficXmp "        pour indMachine de1a nbMachines"
puts $ficXmp "              affecter machineTacheNumero\[ indTache , indMachine \] <-- 0"
puts $ficXmp "              affecter machineTacheDuree\[ indTache , indMachine \]  <-- (-1)"
puts $ficXmp "        fin_pour # indMachine de1a nbMachines"
puts $ficXmp "   fin_pour # indTache de1a nbTaches"
puts $ficXmp "   "
puts $ficXmp "   # 2.2 Boucle d'affectation"
puts $ficXmp "   "
puts $ficXmp "   affecter tempsPris   <-- 0"
puts $ficXmp "   affecter machineCour <-- 1 "
puts $ficXmp "   pour indTache de1a nbTaches "
puts $ficXmp "       affecter dureeCour <-- dureeTache\[ indTache \]"
puts $ficXmp "   "
puts $ficXmp "       si tempsPris+dureeCour <=  dureeMin"
puts $ficXmp "   "
puts $ficXmp "          alors # on peut affecter toute la tache a la machine courante"
puts $ficXmp "   "
puts $ficXmp "                affecter tacheCour                                      <--  nbTache\[ machineCour \] + 1"
puts $ficXmp "                affecter nbTache\[ machineCour \]                         <--  tacheCour"
puts $ficXmp "                affecter machineTacheNumero\[ machineCour , tacheCour \]  <--  indTache  "
puts $ficXmp "                affecter machineTacheDuree\[  machineCour , tacheCour \]  <--  dureeCour "
puts $ficXmp "                affecter tempsPris                                      <--  tempsPris + dureeCour "
puts $ficXmp "                si tempsPris = dureeMin "
puts $ficXmp "                   alors affecter machineCour <-- machineCour + 1"
puts $ficXmp "                         affecter tempsPris   <-- 0"
puts $ficXmp "                fin_si # tempsPris = dureeMin"
puts $ficXmp "   "
puts $ficXmp "          sinon # on n'a le droit d'affecter qu'une partie a la machine courante"
puts $ficXmp "   "
puts $ficXmp "                affecter tacheCour                                     <--  nbTache\[ machineCour \] + 1"
puts $ficXmp "                affecter nbTache\[ machineCour \]                        <--  tacheCour"
puts $ficXmp "                affecter machineTacheNumero\[ machineCour , tacheCour \] <--  indTache"
puts $ficXmp "                affecter resteTemps                                    <--  dureeMin - tempsPris"
puts $ficXmp "                affecter machineTacheDuree\[  machineCour , tacheCour \] <--  resteTemps"
puts $ficXmp "   "
puts $ficXmp "                # et on affecte ce qui reste a la machine suivante"
puts $ficXmp "   "
puts $ficXmp "                affecter machineCour                                   <--  machineCour + 1"
puts $ficXmp "                affecter tacheCour                                     <--  nbTache\[ machineCour \] + 1"
puts $ficXmp "                affecter nbTache\[ machineCour \]                        <--  tacheCour"
puts $ficXmp "                affecter machineTacheNumero\[ machineCour , tacheCour \] <--  indTache"
puts $ficXmp "                affecter machineTacheDuree\[  machineCour , tacheCour \] <--  dureeCour - resteTemps"
puts $ficXmp "                affecter tempsPris                                     <--  dureeCour - resteTemps"
puts $ficXmp "   "
puts $ficXmp "       fin_si # tempsPris+dureeTache\[ tacheCour \] <=  dureeMin"
puts $ficXmp "   "
puts $ficXmp "   fin_pour # indTache de1a nbTaches"
puts $ficXmp "   "
puts $ficXmp "   # 3. Affichage des rpartitions"
puts $ficXmp "   "
puts $ficXmp "   pour indMachine de1a nbMachines"
puts $ficXmp "       crire \"  -- machine \" , indMachine , \" : \""
puts $ficXmp "       affecter nbTacheCour <-- nbTache\[ indMachine \]"
puts $ficXmp "       si nbTacheCour > 0"
puts $ficXmp "          alors"
puts $ficXmp "                pour indTache de1 nbTacheCour"
puts $ficXmp "                     affecter dureeCour <-- machineTacheDuree\[  indMachine , indTache \]"
puts $ficXmp "                     affecter tacheCour <-- machineTacheNumero\[ indMachine , indTache \]"
puts $ficXmp "                     crire   \"          ===========> tache \" , tacheCour , \" dure \" , dureeCour"
puts $ficXmp "                fin_pour # indTache de1 nbTacheCour"
puts $ficXmp "       fin_si # numMachine > 0"
puts $ficXmp "   fin_pour # indTache de1a nbTaches"
puts $ficXmp ""
puts $ficXmp ""

} ; # fin de l'exemple glouton

"trifus" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "# trifus.alg : tri-fusion de fichiers-textes dj      #"
puts $ficXmp "#              tris par ordre alphabtique            #"
puts $ficXmp "# -- auteur (gH)                                       #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp "   # nommage des variables pour noms de fichier "
puts $ficXmp "    "
puts $ficXmp "   affecter nomFic1 <-- \"triFus.f1\" "
puts $ficXmp "   affecter nomFic2 <-- \"triFus.f2\" "
puts $ficXmp "   affecter nomFic3 <-- \"triFus.f3\" "
puts $ficXmp "    "
puts $ficXmp "   # initialisation des nombres de lignes lues et crites "
puts $ficXmp "    "
puts $ficXmp "   affecter nbl1 <-- 0 "
puts $ficXmp "   affecter nbl2 <-- 0 "
puts $ficXmp "   affecter nbl3 <-- 0 "
puts $ficXmp "    "
puts $ficXmp "   # ouverture des 3 fichiers "
puts $ficXmp "    "
puts $ficXmp "   ouvrir nomFic1 en_lecture  comme fic1 "
puts $ficXmp "   ouvrir nomFic2 en_lecture  comme fic2 "
puts $ficXmp "   ouvrir nomFic3 en_criture comme fic3 "
puts $ficXmp "    "
puts $ficXmp "   # lecture du premier enregistrement sur fic1 "
puts $ficXmp "    "
puts $ficXmp "   si non fin_de_fichier(fic1) "
puts $ficXmp "      alors # lecture possible "
puts $ficXmp "            lire ligne1 sur fic1 "
puts $ficXmp "            affecter nbl1 <-- nbl1 + 1 "
puts $ficXmp "   fin_si # lecture du fic1 "
puts $ficXmp "    "
puts $ficXmp "   # lecture du premier enregistrement sur fic2 "
puts $ficXmp "    "
puts $ficXmp "   si non fin_de_fichier(fic2) "
puts $ficXmp "      alors # lecture possible "
puts $ficXmp "            lire ligne2 sur fic2 "
puts $ficXmp "            affecter nbl2 <-- nbl2 + 1 "
puts $ficXmp "   fin_si # lecture du fic1 "
puts $ficXmp "    "
puts $ficXmp "   # boucle de tri-fusion "
puts $ficXmp "    "
puts $ficXmp "   tant_que (non fin_de_fichier(fic1)) et (non fin_de_fichier(fic2)) "
puts $ficXmp "     si _mot(ligne1,2) <= _mot(ligne2,2) "
puts $ficXmp "        alors  # criture de fic1 vers fic3 "
puts $ficXmp "               crire \" (fic1) \" , ligne1 sur fic3 "
puts $ficXmp "               affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "               si (non fin_de_fichier(fic1)) "
puts $ficXmp "                  alors # lecture possible "
puts $ficXmp "                        lire ligne1 sur fic1 "
puts $ficXmp "                        affecter nbl1 <-- nbl1 + 1 "
puts $ficXmp "                  sinon affecter ligne1 <-- \"\" "
puts $ficXmp "               fin_si # lecture du fic1 "
puts $ficXmp "        sinon  # criture de fic2 vers fic3 "
puts $ficXmp "               crire \" (fic2) \" , ligne2 sur fic3 "
puts $ficXmp "               affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "               si (non fin_de_fichier(fic2)) "
puts $ficXmp "                  alors  # lecture possible "
puts $ficXmp "                        lire ligne2 sur fic2 "
puts $ficXmp "                        affecter nbl2 <-- nbl2 + 1 "
puts $ficXmp "                  sinon affecter ligne2 <-- \"\" "
puts $ficXmp "               fin_si # lecture du fic2 "
puts $ficXmp "     fin_si # comparaison ligne 1 et ligne 2 "
puts $ficXmp "   fin_tant_que # lecture sur les deux fichiers "
puts $ficXmp "    "
puts $ficXmp "   si (_longueur(ligne1)>0) et (_longueur(ligne2)>0) "
puts $ficXmp "        alors "
puts $ficXmp "              si _mot(ligne1,2) <= _mot(ligne2,2) "
puts $ficXmp "                 alors  # criture de fic1 vers fic3 "
puts $ficXmp "                        crire \" (fic1) \" , ligne1 sur fic3 "
puts $ficXmp "                        affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "                        crire \" (fic2) \" , ligne2 sur fic3 "
puts $ficXmp "                        affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "                 sinon  # criture de fic2 vers fic3 "
puts $ficXmp "                        crire \" (fic2) \" , ligne2 sur fic3 "
puts $ficXmp "                        affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "                        crire \" (fic1) \" , ligne1 sur fic3 "
puts $ficXmp "                        affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "              fin_si # comparaison ligne 1 et ligne 2 "
puts $ficXmp "   fin_si # on compare en fin de fichier "
puts $ficXmp "    "
puts $ficXmp "   # s'il reste des lignes dans f1, on recopie f1 "
puts $ficXmp "    "
puts $ficXmp "   tant_que non fin_de_fichier(fic1) "
puts $ficXmp "        lire   ligne1 sur fic1 "
puts $ficXmp "        affecter nbl1 <-- nbl1 + 1 "
puts $ficXmp "        crire \" \[fic1\] \" , ligne1 sur fic3 "
puts $ficXmp "        affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "   fin_tant_que # lecture sur f1 "
puts $ficXmp "    "
puts $ficXmp "   # s'il reste des lignes dans f2, on recopie f2 "
puts $ficXmp "    "
puts $ficXmp "   tant_que non fin_de_fichier(fic2) "
puts $ficXmp "        lire   ligne2 sur fic2 "
puts $ficXmp "        affecter nbl2 <-- nbl2 + 1 "
puts $ficXmp "        crire \" \[fic2\] \" , ligne2 sur fic3 "
puts $ficXmp "        affecter nbl3 <-- nbl3 + 1 "
puts $ficXmp "   fin_tant_que # lecture sur f1 "
puts $ficXmp "    "
puts $ficXmp "   # fermeture des fichiers "
puts $ficXmp "    "
puts $ficXmp "   fermer fic1 "
puts $ficXmp "   fermer fic2 "
puts $ficXmp "   fermer fic3 "
puts $ficXmp "    "
puts $ficXmp "   # affichage du nombre de lignes lues et crites : "
puts $ficXmp "    "
puts $ficXmp "   crire \"    \"  , format(nbl1,4) , \" lignes lues    sur \" , nomFic1 "
puts $ficXmp "   crire \"    \"  , format(nbl2,4) , \" lignes lues    sur \" , nomFic2 "
puts $ficXmp "   crire \"    \"  , format(nbl3,4) , \" lignes crites sur \" , nomFic3 "
puts $ficXmp "    "
puts $ficXmp "   quitter 0 "
puts $ficXmp "                                                                       "

} ; # fin de l'exemple trifus

"creedic" {

puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "# creeidc.alg : cration des dictionnaires             #"
puts $ficXmp "#               d'un fichier texte                     #"
puts $ficXmp "# -- auteur (gH)                                       #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp "#                                                      #"
puts $ficXmp "#   Cration des dictionnaires alphabtique            #"
puts $ficXmp "#   et d'occurence de la variable fichier FICT         #"
puts $ficXmp "#                                                      #"
puts $ficXmp "########################################################"
puts $ficXmp ""
puts $ficXmp "#        Version 2 : tableaux et boucles classiques"
puts $ficXmp "#        voir \"Algorithmique raisonne, G. Hunault (2000)\""
puts $ficXmp "#        pour plus de prcisions sur le langage"
puts $ficXmp "#        utilis et les raisons de l'utiliser "
puts $ficXmp ""
puts $ficXmp "# 1. Parcours du fichier texte et comptage des"
puts $ficXmp "#    mots  la vole"
puts $ficXmp "#    NBMT   est le nombre de mots en tout"
puts $ficXmp "#    NBML   est le nombre de la ligne courante"
puts $ficXmp "#    NBDIFM contient le nombres de mots diffrents"
puts $ficXmp "#    TMOT   est le tableau dont les indices"
puts $ficXmp "#           sont numriques et les valeurs sont les mots"
puts $ficXmp "#    TOCC   est le tableau  qui contient en mme"
puts $ficXmp "#           position le nombre d'occurence du mot"
puts $ficXmp ""
puts $ficXmp "     AFFECTER NbMt   <-- 0"
puts $ficXmp "     AFFECTER NbDifM <-- 0"
puts $ficXmp "   "
puts $ficXmp "     TANT_QUE fin_de_fichier( ficT ) = 0"
puts $ficXmp "   "
puts $ficXmp "        LIRE ligneTexte SUR ficT # ligne courante"
puts $ficXmp "        AFFECTER NbMl <-- NbMots( ligneTexte )"
puts $ficXmp "        AFFECTER NbMt <-- NbMt + NbMl"
puts $ficXmp "   "
puts $ficXmp "        POUR indM DE1A NbMl"
puts $ficXmp "             # gestion du mot courant"
puts $ficXmp "             AFFECTER motC <-- MotNumero( indM , ligneTexte ) "
puts $ficXmp "             AFFECTER pdM  <-- position( motC , TMOT )"
puts $ficXmp "             SI pdM = 0"
puts $ficXmp "                ALORS "
puts $ficXmp "                      AFFECTER NbDifM <-- NbDifM + 1"
puts $ficXmp "                      AFFECTER TMOT\[ NbDifM \] <-- motC"
puts $ficXmp "                      AFFECTER TOCC\[ NbDifM \] <-- 1"
puts $ficXmp "                SINON "
puts $ficXmp "                      AFFECTER TOCC\[ pdM \]    <-- TOCC\[ pdM \] + 1"
puts $ficXmp "             FIN_SI # pdM = 0"
puts $ficXmp "        FIN_POUR # indM DE1A NbMl"
puts $ficXmp "   "
puts $ficXmp "     FIN_TANT_QUE # fin_de_fichier( ficT ) = 0"
puts $ficXmp "   "
puts $ficXmp "   "
puts $ficXmp "   # 2. Tri du dictionnaire et recopie"
puts $ficXmp "   #    dans le fichier Dico.Alp"
puts $ficXmp "   #    (ordre alphabtique croissant)"
puts $ficXmp "   "
puts $ficXmp "     APPELER TrieTableaux( tMot, tOcc )"
puts $ficXmp "   "
puts $ficXmp "     OUVRIR \"Dico.Alp\" EN_ECRITURE COMME FdicAlpha"
puts $ficXmp "   "
puts $ficXmp "     POUR indM DE1A NbDifM"
puts $ficXmp "        AFFECTER motC <-- tMot\[ indM \]"
puts $ficXmp "        AFFECTER nbOc <-- tOcc\[ indM \]"
puts $ficXmp "        ECRIRE FormatCar( motC , 20 ) , Format( nbOc , 6) SUR  FdicAlpha"
puts $ficXmp "     FIN_POUR # indM DE1A NbDifM"
puts $ficXmp "   "
puts $ficXmp "     FERMER FdicAlpha"
puts $ficXmp "   "
puts $ficXmp "   # 3. Tri du fichier des mots et recopie"
puts $ficXmp "   #    dans le fichier Dico.Ocd"
puts $ficXmp "   #    (ordre d'occurences dcroissant)"
puts $ficXmp "   "
puts $ficXmp "     OUVRIR \"Dico.Ocd\" EN_ECRITURE COMME FdicOccd"
puts $ficXmp "   "
puts $ficXmp "   # on trie sur le mot numro  2 (nb d'occurences)"
puts $ficXmp "   "
puts $ficXmp "     APPELER TrieFichierSuivant(  FdicAlpha , FdicOccd , 2 )"
puts $ficXmp "   "
puts $ficXmp "     crire \"Vous pouvez utiliser Dico.Alp et Dico.cd.\""
puts $ficXmp ""
puts $ficXmp ""

} ; # fin de l'exemple creedic

"default" {  }

} ; # fin de switch

close $ficXmp

# le fichier est crit, on l'ouvre dans l'diteur

set etatF      0
set fichierAlg $algXmp
voirFichier    "alg"

} ; # fin proc exemple

# ********************************************************************************

proc recreeRex { nomf lang } { global nomOs

  set extf [extlang $lang]

  if [catch {open "$nomf.rex" "w" } fileJd] {
        tk_messageBox -parent . -title "Erreur" -message "Impossible de crer $nomf " -icon error -type ok
        return
  } else {
    puts  $fileJd "/* $nomf.rex [dateHeure] */\n"
    puts  $fileJd " parse arg fn prms\n "
    puts  $fileJd " say \" $nomf.rex : gestion de l'excution pour le langage $lang \"\n"

    set   longext [string length ".extf"]
    puts  $fileJd " if words(fn)=0 then do "
    puts  $fileJd "    say \"     syntaxe : $nomf nomfic parms \" "
    puts  $fileJd "    say \"     exemple : $nomf demo oui 10 \" "
    puts  $fileJd "    say \"(ce script rajoute .$extf l o il faut).\" "
    puts  $fileJd "    exit "
    puts  $fileJd " end "
    puts  $fileJd " "
    puts  $fileJd " if length(fn)>$longext then do "
    puts  $fileJd "    if substr(fn,length(fn)-1,$longext) = \".$extf\" then do "
    puts  $fileJd "        fnc = fn "
    puts  $fileJd "        fn  = substr(fn,1,length(fn)-$longext) "
    puts  $fileJd "    end ; else ; do ; "
    puts  $fileJd "        fnc = fn||\".$extf\" "
    puts  $fileJd "    end "
    puts  $fileJd " end ; else ; do ; "
    puts  $fileJd "   fnc = fn||\".$extf\" "
    puts  $fileJd " end "

    # suppression de fichiers

    if { $lang == "C" || $lang == "C++" || $lang == "Pascal" } {  set ftD "fn" }
    if { $lang == "Dbase" } {  set ftD "fn.max" }
    if { $lang == "Java"  } {  set ftD "fn.class" }

    if { $nomOs == "Windows"} {
       puts  $fileJd "  \" if exist \" $ftD \" del \" $ftD   "
    } else {
       puts  $fileJd "  \" rm -f \" $ftD  "
    } ; # fin si

    # commande de compilation

    switch -exact -- $lang {
      "C"      {  puts  $fileJd "\n cmd = \"gcc -ansi -pedantic -Wall -Werror -lm -o\" fn  \" \" fnc \n" }
      "C++"    {  puts  $fileJd "\n cmd = \"g++ -o \" fn \" \" fnc   " }
      "Java"   {  puts  $fileJd "\n cmd = \"javac \" fnj " }
      "Dbase"  {  puts  $fileJd "\n cmd = \"max \" fn    " }
      "Pascal" {  puts  $fileJd "\n cmd = \"ppc386 \" fn " }
      default  {  }
    } ; # fin de switch

    puts  $fileJd " say cmd"
    puts  $fileJd " cmd"
    puts  $fileJd " sovRc = rc"
    puts  $fileJd " say \" code retour : \" sovRc"
    puts  $fileJd " call charout , \" ok  ?\" "
    puts  $fileJd " pull ."
    puts  $fileJd " if sovRc=0 then do"

    # commande d'xcution

    if { $lang == "C" || $lang == "C++" || $lang == "Pascal" } {
       if { $nomOs == "Windows"} {
         puts  $fileJd "   say  \" excution : .\\\"||fn prms"
         puts  $fileJd "   \".\\\"||fn prms"
       } else {
         puts  $fileJd "   say  \" excution : ./\"||fn prms"
         puts  $fileJd "   \"./\"||fn prms"
       } ; # fin si
    } else {

      if { $lang == "Dbase" } {
         puts  $fileJd "   say  \" excution : maxrun \"||fn \" -p \" prms"
         puts  $fileJd "   \"maxrun \"||fn  \" -p \" prms "
      } ; # finsi Dbase

      if { $lang == "Java" } {
         puts  $fileJd "   say  \" excution : java -classpath . \"||fn prms "
         puts  $fileJd "   \"java -classpath . \"||fn prms "
      } ; # finsi Dbase

    } ; # fin si sur langage

    # affichage des fichiers

    if { $nomOs == "Windows"} {
         puts  $fileJd "   \"dir \"fn\".*\""
    } else {
         puts  $fileJd "   \"ls -al \"fn\".*\""
    } ; # fin si

    puts  $fileJd " end ; else ; do ;"
    puts  $fileJd "    exit sovRc"
    puts  $fileJd " end ;"

    close $fileJd
  } ; # fin si catch a chou

  return "$nomf.rex"

} ; #  fin proc recreeRex

# ********************************************************************************

proc recreeScript { nomlang } { global lstLang runLang cmdLang nomOs

  set bazScr $runLang("$nomlang")
  set nomScr $runLang("$nomlang")
  if { $nomOs == "Windows" } { append nomScr ".bat" }
  set nomRex "$bazScr"
  set creeFic "$nomScr"
  file delete -force $nomScr
ecritDbg " script $nomScr "
  if [catch {open $nomScr "w" } fileId] {
        tk_messageBox -parent . -title "Erreur" -message "Impossible de crer $nomScr " -icon error -type ok
        return
  } else {
      if { $nomOs == "Windows" } { puts $fileId "@echo off"
         set laCmd "puts $fileId \"regina C:\\\\Galg\\\\$bazScr.rex %1 %2 %3 %4 %5 %6 %7 %8 %9 \" "
      } else {
         set laCmd "puts $fileId \"regina ~/Galg/$bazScr.rex %1 %2 %3 %4 %5 %6 %7 %8 %9 \" "
      } ; # finsi Windows
         switch  -exact -- $nomlang {
         "C"      { eval $laCmd ; append creeFic ", [recreeRex $nomRex $nomlang]" ; }
         "C++"    { eval $laCmd ; append creeFic ", [recreeRex $nomRex $nomlang]" ; }
         "Java"   { eval $laCmd ; append creeFic ", [recreeRex $nomRex $nomlang]" ; }
         "Dbase"  { eval $laCmd ; append creeFic ", [recreeRex $nomRex $nomlang]" ; }
         "Pascal" { eval $laCmd ; append creeFic ", [recreeRex $nomRex $nomlang]" ; }
         "Tcl"    { puts $fileId "C:\\Tcl\\tclsh83.exe \%1 \%2 \%3 \%4" ;
                    set creeFic "" }
         "Galg"   {
                       if { $nomOs == "Windows" } {
                            puts $fileId "set PERL_MACROS=C:\\Galg" ;
                            puts $fileId "perl C:\\Galg\\galg.pl \%1 \%2 \%3 \%4 \%5 \%6 \%7 \%8 \%9" ;
                       } else {
                            puts $fileId "set PERL_MACROS=~/Galg/" ;
                            puts $fileId "perl ~/Galg/galg.pl \%1 \%2 \%3 \%4 \%5 \%6 \%7 \%8 \%9" ;
                       } ; # finsi Windows
                    set creeFic $nomScr }
         default  {  }
         } ; # fin du switch

  } ; # fin si catch a chou

  close $fileId

  if { $nomOs == "Linux"   } { eval "exec xterm -e  chmod +x $nomScr" }
puts " recreeScript renvoie $creeFic "
  return $creeFic

} ; # proc recreeScript

# ********************************************************************************

proc recreeScripts { } { global lstLang

ecritDbg " recreeScripts "

  set lstScr "\n\n les fichiers suivants ont t recrs : \n\n"

  foreach lang $lstLang {
ecritDbg " $lang "

     if { $lang!="Perl" && $lang!="Rexx" } {  # attention : galg est mis dans la liste des langages
        set refusCree 0
        if { $lang=="Galg"} {  # on demande s'ilfaut recrer pour galg
           set titreG     " cration du script pour Galg "
           set questionG  " voulez-vous recrer le script pour Galg ?"
           set refusCree  [ tk_dialog .dialogue $titreG $questionG warning 0 Oui Non ] ; # 0 = oui, 1 = non
        } ; # fin si
        if { $refusCree == 0 } {
ecritDbg " $lang $refusCree "
            set nomf [recreeScript $lang]
            if { [string length $nomf] > 0 } { append lstScr "     $nomf\n" }
        } ; # fin si
     } ; # finsi ce n'est ni galg ni perl

  } ; # fin de pour chaque langage

  msgInfo $lstScr

} ; # proc recreeScripts



# *****************************************************************
# *                                                               *
# *                Dtection des versions                         *
# *                                                               *
# *****************************************************************


proc prepLang { } { global  lstLang extLang cmdLang runLang nomTmp ficRex ficTcl

  # lstLang est la liste des langages

  set lstLang "C C++ Dbase Java Pascal Perl Rexx Tcl Galg "

  # extLang est la liste des extensions de fichier associes aux langages

  set extLang "c cpp prg   java pas    pl   rex  tcl alg "

  # pour la version de tcl et rexx, on utilise des fichiers
  # on n'en a pas vraiment besoin pour tcl, mais on le fait
  # pour garder la compatibilit avec les autres interfaces

  set nomRex "ver.rex"
  set nomTcl "ver.tcl"
  set ficRex [file join $nomTmp $nomRex]
  set ficTcl [file join $nomTmp $nomTcl]

  # cmdLang est la commande utilise pour dtecter le langage

  set cmdLang("C")       "gcc    -v"
  set cmdLang("C++")     "g++    -v"
  set cmdLang("Dbase")   "dbase  -help"
  set cmdLang("Java")    "java   -version"
  set cmdLang("Pascal")  "ppc386 -version"
  set cmdLang("Perl")    "perl   -V"
  set cmdLang("Rexx")    "regina $ficRex"
  set cmdLang("Tcl")     "tcl    $ficTcl"

  set cmdLang("Galg")    "galg"

  # runLang est la commande de galg pour excuter le langage

  set runLang("C")       "pc"
  set runLang("C++")     "ppc"
  set runLang("Dbase")   "db"
  set runLang("Java")    "ja"
  set runLang("Pascal")  "pa"
  set runLang("Perl")    "perl -W"
  set runLang("Rexx")    "regina"
  set runLang("Tcl")     "tcl"
  set runLang("Galg")    "galg"

} ; # fin proc prepLang

# ********************************************************************************

proc detecteVersions {} { global nomOs verLang lstLang cmdLang runLang ficRex ficTcl

  # on utilise une liste de langages pour tout dtecter avec une seule boucle

  puts stdout "     Langage     Version                    dtecte par \n\n"

  # passage en revue des langages

  foreach lang $lstLang {

     # pour la version de tcl et rexx, on cre des fichiers

     if { $lang == "Rexx" } {
        set ficR [open $ficRex "w"]
        puts $ficR  "parse version vdr ; say vdr\n "
        close $ficR
     } ;  # fin de cration du fichier Rexx

     if { $lang == "Tcl" } {
        set ficT [open $ficTcl "w"]
        puts $ficT  "puts stdout \"version \$tcl_version\n\""
        close $ficT
     } ;  # fin de cration du fichier Tcl

     # on essaie d'excuter la commande et de rcuprer sa sortie

     set cmd $cmdLang("$lang")
     set vers    "absent"
     set version "Absent"

     if [catch { eval exec $cmdLang("$lang") } res] {

        # gcc -v, g++ -v et java -version renvoient leurs sorties vers stderr

        switch  -exact -- $lang {
         "C"      {  regexp -nocase {gcc version ([0-9]*.[0-9]*.[0-9]*)} $res -> version }
         "C++"    {  regexp -nocase {gcc version ([0-9]*.[0-9]*.[0-9]*)} $res -> version }
         "Java"   {  regexp -nocase {version "(.*)"}                     $res -> version }
         "Dbase"  {  regexp -nocase {Version ([0-9]*.[0-9]*)}            $res -> version }
         "Pascal" {  regexp -nocase {Version ([0-9]*.[0-9]*.[0-9]*)}     $res -> version }
         "Tcl"    {  regexp -nocase {version "(.*)"}                     $res -> version }
         default  {  set version "ABSENT" }
        } ; # fin du switch

     } else {

       switch  -exact -- $lang {
         "Perl"  { regexp -nocase {revision ([0-9]*)}   $res -> perlRevision
                   regexp -nocase {version ([0-9]*)}    $res -> perlVersion
                   regexp -nocase {subversion ([0-9]*)} $res -> perlSubVersion
                   set version "v$perlRevision.$perlVersion.$perlSubVersion"
                 }  ; # fin du cas Perl
         "Rexx"  {  regexp -nocase {([^ ]+ [^ ]+) } $res -> versionLongue
                    regexp -nocase {Regina_(.*)}    $versionLongue -> version
                 }  ; # fin du cas Rexx
         "Galg"  {  regexp -nocase {version ([0-9]*).([0-9]*)} $res -> galgVersionMajor galgVersionMinor
                    if [info exists galgVersionMajor] { set version "$galgVersionMajor.$galgVersionMinor" }
                 }  ; # fin du cas Galg
         default {  set version "absenT" }
       } ; # fin du switch

     } ; # fin du catch exec

     set vers $version

     # on formate les sorties avant d'afficher

     set f_lang [string range " $lang         " 0 7]
     set f_vers [string range " $vers                            " 0 17]
     if { $lang == "Galg" } { puts stdout "" }
     puts stdout "      $f_lang    $f_vers        $cmdLang("$lang")"
     set verLang("$lang") $vers

  } ; # fin de pour chaque langage

  # on ne dtruit pas les fichiers crs pour Rexx et Tcl
  # car on peut ainsi rexcuter la commande pour connaitre
  # la version

  # file delete -force $ficRex
  # file delete -force $ficTcl

} ; # fin de proc detecteVersions

# ********************************************************************************

proc aideClavier { } {

set msgClavier ""

append msgClavier " Controle a : voir l'Algorithme                                \n"
append msgClavier " Controle b : Bascule mode dbutant / expert                   \n"
append msgClavier " Controle c : copier la slection                              \n"
append msgClavier " Controle d : langages Dtects comme prsents                 \n"
append msgClavier " Controle e : va  la premire erreur dtecte                 \n"
append msgClavier " Controle f : ouvrir un fichier algorithme                     \n"
append msgClavier " Controle g : lancer l'analyse avec Galg                       \n"
append msgClavier " Controle h : aide sur galg                                    \n"
append msgClavier " Controle i : insrer un commentaire                           \n"
append msgClavier " Controle j : aller  la ligne n                               \n"
append msgClavier " Controle k : raccourcis clavier (cette liste)                 \n"
append msgClavier " Controle l : voir le Listing de l'analyse                     \n"
append msgClavier " Controle m : voir le fichier des variables et Modules         \n"
append msgClavier " Controle n : crire un Nouvel algorithme                      \n"
append msgClavier " Controle o : rouvrir l'algorithme                            \n"
append msgClavier " Controle p :  Propos                                         \n"
append msgClavier " Controle q : Quitter                                          \n"
append msgClavier " Controle r : dition des paRamtres d'excution               \n"
append msgClavier " Controle s : enregiStrer l'algorithme courant                 \n"
append msgClavier " Controle t : voir la Traduction                               \n"
append msgClavier " Controle u : langages sUpports                               \n"
append msgClavier " Controle v : coller la slection                              \n"
append msgClavier " Controle w : enregistrer Sous                                 \n"
append msgClavier " Controle x : eXit (sans sauvegarde)                           \n"
append msgClavier " Controle y : dtruit la ligne courante                        \n"
append msgClavier " Controle z : recrer les scripts d'excution                  \n"
append msgClavier " Controle + : taille plus grande                               \n"
append msgClavier " Controle - : taille plus petite                               \n"

 tk_messageBox -title "Raccourcis claviers" -icon info -type ok -message $msgClavier

} ; # fin proc aideClavier

# ********************************************************************************

proc touchesClavier { } { global nomOs

 bind . <Control-a>  { voirAlgo          }
 bind . <Control-b>  { modeExpert        } ; # Full text messages
#bind . <Control-c>  { copier            }
 bind . <Control-d>  { langagesPresents  }
 bind . <Control-e>  { premiereErreur    }
 bind . <Control-f>  { ouvreFichier      }
 bind . <Control-g>  { analyser          }
 bind . <Control-h>  { aideWeb           }
 bind . <Control-i>  { insereCommentaire }
 bind . <Control-j>  { allerALaLigne     }
 bind . <Control-k>  { aideClavier       }
 bind . <Control-l>  { voirListing       }
 bind . <Control-m>  { voirVariables     }
 bind . <Control-n>  { nouveauFichier    }
 bind . <Control-o>  { reOuvreFichier    }
 bind . <Control-p>  { aPropos           }
 bind . <Control-q>  { quitter           }
 bind . <Control-r>  { parametresExec    } ; # runTime
 bind . <Control-s>  { enregistrer       }
 bind . <Control-t>  { voirTraduction    }
 bind . <Control-u>  { langagesSupportes }
# bind . <Control-v>  { selection get     }
 bind . <Control-w>  { enregistrerSous   }
 bind . <Control-y>  { detruitLigne      }
 bind . <Control-x>  { exit              }
 bind . <Control-z>  { recreeScripts     }

if  { $nomOs == "Windows"   } {

 bind . <Control-plus>    { taille "+"  } ; # touche 1
 bind . <Control-minus>   { taille "-"  } ; # touche 1

} ; # fin si Linux

if  { $nomOs == "Linux"   } {

 bind . <Control-KP_End>    { exemple "bonjour"  } ; # touche 1
 bind . <Control-KP_Down>   { exemple "secondes" } ; # touche 2
 bind . <Control-KP_Next>   { exemple "tabmult"  } ; # touche 3
 bind . <Control-KP_Left>   { exemple "cfe"      } ; # touche 4
 bind . <Control-KP_Begin>  { exemple "maxocc"   } ; # touche 5
 bind . <Control-KP_Right>  { exemple "brutese"  } ; # touche 6
 bind . <Control-KP_Home>   { exemple "glouton"  } ; # touche 7
 bind . <Control-KP_Up>     { exemple "trifus"   } ; # touche 8
 bind . <Control-KP_Prior>  { exemple "creedic"  } ; # touche 9

 bind . <Control-KP_Add>       { taille "+"  } ; # control +
 bind . <Control-KP_Subtract>  { taille "-"  } ; # control -

 bind . <Control-KP_1>  { exemple "bonjour"  } ; # touche 1
 bind . <Control-KP_2>  { exemple "secondes" } ; # touche 2
 bind . <Control-KP_3>  { exemple "tabmult"  } ; # touche 3
 bind . <Control-KP_4>  { exemple "cfe"      } ; # touche 4
 bind . <Control-KP_5>  { exemple "maxocc"   } ; # touche 5
 bind . <Control-KP_6>  { exemple "brutese"  } ; # touche 6
 bind . <Control-KP_7>  { exemple "glouton"  } ; # touche 7
 bind . <Control-KP_8>  { exemple "trifus"   } ; # touche 8
 bind . <Control-KP_9>  { exemple "creedic"  } ; # touche 9

 bind . <Control-Menu>  { exemple "trifus"   } ; # touche 8

} ; # fin si Linux

# ********************************************************************************

} ; # fin de proc touchesClavier

proc ecritDbg { letxt } { global fDbg dbg

if { $dbg > 0 } {
   set    idbg   [open $fDbg "a"]
   puts  $idbg   $letxt
   close $idbg
} ; # fin si

} ; # fin de proc ecritDbg

# *****************************************************************
# *****************************************************************
# *****************************************************************
# **                                                             **
# **     Main proc (programme principal)                         **
# **                                                             **
# *****************************************************************
# *****************************************************************
# *****************************************************************


# utilisation ventuelle d'un fichier de dbogagge

set  dbg 1  ; # 0 = pas de debug (valeur par dfaut) ; 1 = debug
set  fDbg   "galgtcl.dbg"
file delete $fDbg
if  { $dbg > 0 } {
      set  idbg   [open $fDbg "w"]
      puts  $idbg  "\n\n -- [dateHeure] debug de l'interface en tcl pour Galg \n\n"
      close $idbg
} ; # finsi

# affichage du titre

puts  stdout "\n\n -- interface en tcl pour Galg \n\n"

# pour surveiller les touches clavier utilises


# de quel OS s'agit-il ? (on en dduira le rpertoire temporaire.)
# on utilise aussi la variable d'environnement Temp car C:\Temp
# n'est pas forcment accessible (par exemple  la fac)

set nomOs  [lindex $tcl_platform(os) 0]
set nomTmp "."
set nomBrowser "?"

if  { $nomOs == "Windows" } {
      catch { set nomTmp $env(TEMP) }
} ; # fin si Windows

if  { $nomOs == "Linux"   } {
      set nomTmp "/tmp" ;
} ; # fin si Linux

catch {  set nomBrowser $env(BROWSER) }

if  { $dbg == 1 } {
  puts stdout " Systme d'exploitation : $nomOs ; temporaire : $nomTmp"
  ecritDbg    " Systme d'exploitation : $nomOs ; temporaire : $nomTmp"
  puts stdout " Navigateur : $nomBrowser \n"
  ecritDbg    " Navigateur : $nomBrowser \n"
} ; # fin de debug

# dfinition des langages, extensions et commandes associes
# dtection du numro de version pour les langages et pour Galg

prepLang
detecteVersions

# prparation des variables pour grer l'dition
# touches ne dclenchant pas de modification

set lstNoModif "Up Down left Right Mode_switch Alt_L Control_L Control_R"
set prevCar ""
set ancV ""
set newV ""
set nbErr 0

# initialisation des variables globales lies  l'algorithme

set fichierModifie false
set fichierAlg     "Nouvel algorithme"
set fichierTraduit "aucun"
set langU          ""
set nomAlg         "Nouvel algorithme"
set naturF         "alg"
set etatF          0
set action         0

# ***** Configuration de la fentre principale *****

wm title . "GALG - Gestion d'ALGorithmes version $gVersion "

# gestion de la taille de la fentre en fonction de la rsolution de l'cran

tailleWin

# cration du menu

set valParam ""        ; # par dfaut, aucun paramtre

set   .menubar [construitMenus]
.      config -menu .menubar
set   .editeur [construitEditeur]
set   .barreDeSatut [construitBarreDeStatut]
pack  .editeur -fill both -expand true
pack  .barreDeStatut -fill x

# dfinition du mode d'Affichage

set modeAff "Expert"   ; # par dfaut : Dbutant ; autre choix possible : Expert
set modeAff "Dbutant" ; # par dfaut : Dbutant ; autre choix possible : Expert
modeExpert             ; # active le choix prcdent


# comme leurs noms l'indiquent...

gestionEvenements
touchesClavier

# si galg non prsent, on prvient

if {[string toupper $verLang("Galg")]=="ABSENT"} {
     tk_messageBox -parent . -title "Avertissement" -message "Attention -- (gH) : galg non dtect" -icon error -type ok -default ok
} ; # fin si

# si on a entr un nom d'algorithme en ligne de commande,
# il faut ouvrir l'algorithme correspondant

if { $argc <= 0 } {
  nouveauFichier
} else {
  puts " algorithme : [lindex $argv 0] "
  set fileN [lindex $argv 0]
  set nouveauFichier [file tail $fileN]
  cd  [file dirname $fileN]
  set fichierAlg     $nouveauFichier
  voirFichier        "alg"
} ; # fin de si

focus -force .editeur.texte

#  (gH)   --  fin du fichier galg.tcl
